"""This module makes available standard errno system symbols.

The value of each symbol is the corresponding integer value,
e.g., on most systems, errno.ENOENT equals the integer 2.

The dictionary errno.errorcode maps numeric codes to symbol names,
e.g., errno.errorcode[2] could be the string 'ENOENT'.

Symbols that are not relevant to the underlying system are not defined.

To map error codes to error messages, use the function os.strerror(),
e.g. os.strerror(2) could return 'No such file or directory'."""


E2BIG = 7

EACCES = 13

EADDRINUSE = 10048

EADDRNOTAVAIL = 10049

EAFNOSUPPORT = 10047

EAGAIN = 11

EALREADY = 10037

EBADF = 9

EBADMSG = 104

EBUSY = 16

ECANCELED = 105

ECHILD = 10

ECONNABORTED = 10053

ECONNREFUSED = 10061

ECONNRESET = 10054

EDEADLK = 36

EDEADLOCK = 36

EDESTADDRREQ = 10039

EDOM = 33

EDQUOT = 10069

EEXIST = 17

EFAULT = 14

EFBIG = 27

EHOSTDOWN = 10064

EHOSTUNREACH = 10065

EIDRM = 111

EILSEQ = 42

EINPROGRESS = 10036

EINTR = 4

EINVAL = 22

EIO = 5

EISCONN = 10056

EISDIR = 21

ELOOP = 10062

EMFILE = 24

EMLINK = 31

EMSGSIZE = 10040

ENAMETOOLONG = 38

ENETDOWN = 10050

ENETRESET = 10052

ENETUNREACH = 10051

ENFILE = 23

ENOBUFS = 10055

ENODATA = 120

ENODEV = 19

ENOENT = 2

ENOEXEC = 8

ENOLCK = 39

ENOLINK = 121

ENOMEM = 12

ENOMSG = 122

ENOPROTOOPT = 10042

ENOSPC = 28

ENOSR = 124

ENOSTR = 125

ENOSYS = 40

ENOTCONN = 10057

ENOTDIR = 20

ENOTEMPTY = 41

ENOTRECOVERABLE = 127

ENOTSOCK = 10038

ENOTSUP = 129

ENOTTY = 25

ENXIO = 6

EOPNOTSUPP = 10045

EOVERFLOW = 132

EOWNERDEAD = 133

EPERM = 1

EPFNOSUPPORT = 10046

EPIPE = 32

EPROTO = 134

EPROTONOSUPPORT = 10043

EPROTOTYPE = 10041

ERANGE = 34

EREMOTE = 10071

EROFS = 30

ESHUTDOWN = 10058

ESOCKTNOSUPPORT = 10044

ESPIPE = 29

ESRCH = 3

ESTALE = 10070

ETIME = 137

ETIMEDOUT = 10060

ETOOMANYREFS = 10059

ETXTBSY = 139

EUSERS = 10068

EWOULDBLOCK = 10035

EXDEV = 18

WSABASEERR = 10000

WSAEACCES = 10013

WSAEADDRINUSE = 10048

WSAEADDRNOTAVAIL = 10049

WSAEAFNOSUPPORT = 10047

WSAEALREADY = 10037

WSAEBADF = 10009

WSAECONNABORTED = 10053

WSAECONNREFUSED = 10061

WSAECONNRESET = 10054

WSAEDESTADDRREQ = 10039

WSAEDISCON = 10101

WSAEDQUOT = 10069

WSAEFAULT = 10014

WSAEHOSTDOWN = 10064

WSAEHOSTUNREACH = 10065

WSAEINPROGRESS = 10036

WSAEINTR = 10004

WSAEINVAL = 10022

WSAEISCONN = 10056

WSAELOOP = 10062

WSAEMFILE = 10024

WSAEMSGSIZE = 10040

WSAENAMETOOLONG = 10063

WSAENETDOWN = 10050

WSAENETRESET = 10052

WSAENETUNREACH = 10051

WSAENOBUFS = 10055

WSAENOPROTOOPT = 10042

WSAENOTCONN = 10057

WSAENOTEMPTY = 10066

WSAENOTSOCK = 10038

WSAEOPNOTSUPP = 10045

WSAEPFNOSUPPORT = 10046

WSAEPROCLIM = 10067

WSAEPROTONOSUPPORT = 10043

WSAEPROTOTYPE = 10041

WSAEREMOTE = 10071

WSAESHUTDOWN = 10058

WSAESOCKTNOSUPPORT = 10044

WSAESTALE = 10070

WSAETIMEDOUT = 10060

WSAETOOMANYREFS = 10059

WSAEUSERS = 10068

WSAEWOULDBLOCK = 10035

WSANOTINITIALISED = 10093

WSASYSNOTREADY = 10091

WSAVERNOTSUPPORTED = 10092

errorcode = {v:k for (k, v) in globals().items() if k == k.upper()}
