import unicodedata

tests = {
    "bidirs": {
        "BN": "0000",
        "S": "0009",
        "B": "000A",
        "WS": "000C",
        "ON": "0021",
        "ET": "0023",
        "ES": "002B",
        "CS": "002C",
        "EN": "0030",
        "L": "0041",
        "NSM": "0300",
        "R": "05BE",
        "AN": "0600",
        "AL": "0608",
        "LRE": "202A",
        "RLE": "202B",
        "PDF": "202C",
        "LRO": "202D",
        "RLO": "202E",
        "LRI": "2066",
        "RLI": "2067",
        "FSI": "2068",
        "PDI": "2069"
    },
    "categories": {
        "Cc": "0000",
        "Zs": "0020",
        "Po": "0021",
        "Sc": "0024",
        "Ps": "0028",
        "Pe": "0029",
        "Sm": "002B",
        "Pd": "002D",
        "Nd": "0030",
        "Lu": "0041",
        "Sk": "005E",
        "Pc": "005F",
        "Ll": "0061",
        "So": "00A6",
        "Lo": "00AA",
        "Pi": "00AB",
        "Cf": "00AD",
        "No": "00B2",
        "Pf": "00BB",
        "Lt": "01C5",
        "Lm": "02B0",
        "Mn": "0300",
        "Me": "0488",
        "Mc": "0903",
        "Nl": "16EE",
        "Zl": "2028",
        "Zp": "2029",
        "Cs": "D800",
        "Co": "E000"
    },
    "combinings": {
        "0": "0000",
        "230": "0300",
        "232": "0315",
        "220": "0316",
        "216": "031B",
        "202": "0321",
        "1": "0334",
        "240": "0345",
        "233": "035C",
        "234": "035D",
        "222": "059A",
        "228": "05AE",
        "10": "05B0",
        "11": "05B1",
        "12": "05B2",
        "13": "05B3",
        "14": "05B4",
        "15": "05B5",
        "16": "05B6",
        "17": "05B7",
        "18": "05B8",
        "19": "05B9",
        "20": "05BB",
        "21": "05BC",
        "22": "05BD",
        "23": "05BF",
        "24": "05C1",
        "25": "05C2",
        "30": "0618",
        "31": "0619",
        "32": "061A",
        "27": "064B",
        "28": "064C",
        "29": "064D",
        "33": "0651",
        "34": "0652",
        "35": "0670",
        "36": "0711",
        "7": "093C",
        "9": "094D",
        "84": "0C55",
        "91": "0C56",
        "103": "0E38",
        "107": "0E48",
        "118": "0EB8",
        "122": "0EC8",
        "129": "0F71",
        "130": "0F72",
        "132": "0F74",
        "214": "1DCE",
        "218": "1DFA",
        "224": "302E",
        "8": "3099",
        "26": "FB1E",
        "6": "16FF0",
        "226": "1D16D"
    },
    "decimals": {
        "": "0000",
        "0": "0030",
        "1": "0031",
        "2": "0032",
        "3": "0033",
        "4": "0034",
        "5": "0035",
        "6": "0036",
        "7": "0037",
        "8": "0038",
        "9": "0039"
    },
    "decompositions": {
        "": "0000",
        "<noBreak> 0020": "00A0",
        "<compat> 0020 0308": "00A8",
        "<super> 0061": "00AA",
        "<compat> 0020 0304": "00AF",
        "<super> 0032": "00B2",
        "<super> 0033": "00B3",
        "<compat> 0020 0301": "00B4",
        "<compat> 03BC": "00B5",
        "<compat> 0020 0327": "00B8",
        "<super> 0031": "00B9",
        "<super> 006F": "00BA",
        "<fraction> 0031 2044 0034": "00BC",
        "<fraction> 0031 2044 0032": "00BD",
        "<fraction> 0033 2044 0034": "00BE",
        "0041 0300": "00C0",
        "0041 0301": "00C1",
        "0041 0302": "00C2",
        "0041 0303": "00C3",
        "0041 0308": "00C4",
        "0041 030A": "00C5",
        "0043 0327": "00C7",
        "0045 0300": "00C8",
        "0045 0301": "00C9",
        "0045 0302": "00CA",
        "0045 0308": "00CB",
        "0049 0300": "00CC",
        "0049 0301": "00CD",
        "0049 0302": "00CE",
        "0049 0308": "00CF",
        "004E 0303": "00D1",
        "004F 0300": "00D2",
        "004F 0301": "00D3",
        "004F 0302": "00D4",
        "004F 0303": "00D5",
        "004F 0308": "00D6",
        "0055 0300": "00D9",
        "0055 0301": "00DA",
        "0055 0302": "00DB",
        "0055 0308": "00DC",
        "0059 0301": "00DD",
        "0061 0300": "00E0",
        "0061 0301": "00E1",
        "0061 0302": "00E2",
        "0061 0303": "00E3",
        "0061 0308": "00E4",
        "0061 030A": "00E5",
        "0063 0327": "00E7",
        "0065 0300": "00E8",
        "0065 0301": "00E9",
        "0065 0302": "00EA",
        "0065 0308": "00EB",
        "0069 0300": "00EC",
        "0069 0301": "00ED",
        "0069 0302": "00EE",
        "0069 0308": "00EF",
        "006E 0303": "00F1",
        "006F 0300": "00F2",
        "006F 0301": "00F3",
        "006F 0302": "00F4",
        "006F 0303": "00F5",
        "006F 0308": "00F6",
        "0075 0300": "00F9",
        "0075 0301": "00FA",
        "0075 0302": "00FB",
        "0075 0308": "00FC",
        "0079 0301": "00FD",
        "0079 0308": "00FF",
        "0041 0304": "0100",
        "0061 0304": "0101",
        "0041 0306": "0102",
        "0061 0306": "0103",
        "0041 0328": "0104",
        "0061 0328": "0105",
        "0043 0301": "0106",
        "0063 0301": "0107",
        "0043 0302": "0108",
        "0063 0302": "0109",
        "0043 0307": "010A",
        "0063 0307": "010B",
        "0043 030C": "010C",
        "0063 030C": "010D",
        "0044 030C": "010E",
        "0064 030C": "010F",
        "0045 0304": "0112",
        "0065 0304": "0113",
        "0045 0306": "0114",
        "0065 0306": "0115",
        "0045 0307": "0116",
        "0065 0307": "0117",
        "0045 0328": "0118",
        "0065 0328": "0119",
        "0045 030C": "011A",
        "0065 030C": "011B",
        "0047 0302": "011C",
        "0067 0302": "011D",
        "0047 0306": "011E",
        "0067 0306": "011F",
        "0047 0307": "0120",
        "0067 0307": "0121"
    },
    "digits": {
        "": "0000",
        "0": "0030",
        "1": "0031",
        "2": "0032",
        "3": "0033",
        "4": "0034",
        "5": "0035",
        "6": "0036",
        "7": "0037",
        "8": "0038",
        "9": "0039"
    },
    "names": {
        "<control>": "000A",
        "NUMBER SIGN": "0023",
        "DIGIT THREE": "0033",
        "GREATER-THAN SIGN": "003E",
        "LATIN CAPITAL LETTER J": "004A",
        "LATIN SMALL LETTER H": "0068",
        "DIAERESIS": "00A8",
        "LATIN CAPITAL LETTER E WITH GRAVE": "00C8",
        "LATIN CAPITAL LETTER U WITH DIAERESIS": "00DC",
        "LATIN SMALL LETTER A WITH BREVE": "0103",
        "LATIN CAPITAL LETTER C WITH CARON": "010C",
        "LATIN SMALL LETTER C WITH CARON": "010D",
        "LATIN CAPITAL LETTER H WITH CIRCUMFLEX": "0124",
        "LATIN CAPITAL LETTER I WITH BREVE": "012C",
        "LATIN CAPITAL LETTER J WITH CIRCUMFLEX": "0134",
        "LATIN CAPITAL LETTER O WITH DOUBLE ACUTE": "0150",
        "LATIN SMALL LETTER S WITH CARON": "0161",
        "LATIN CAPITAL LETTER U WITH TILDE": "0168",
        "LATIN CAPITAL LETTER U WITH BREVE": "016C",
        "LATIN CAPITAL LETTER Y WITH CIRCUMFLEX": "0176",
        "LATIN CAPITAL LETTER Y WITH DIAERESIS": "0178",
        "LATIN CAPITAL LETTER Z WITH DOT ABOVE": "017B",
        "LATIN CAPITAL LETTER B WITH HOOK": "0181",
        "LATIN CAPITAL LETTER B WITH TOPBAR": "0182",
        "LATIN CAPITAL LETTER C WITH HOOK": "0187",
        "LATIN SMALL LETTER C WITH HOOK": "0188",
        "LATIN SMALL LETTER L WITH BAR": "019A",
        "LATIN CAPITAL LETTER N WITH LEFT HOOK": "019D",
        "LATIN SMALL LETTER OI": "01A3",
        "LATIN LETTER YR": "01A6",
        "LATIN CAPITAL LETTER ESH": "01A9",
        "LATIN LETTER TWO WITH STROKE": "01BB",
        "LATIN CAPITAL LETTER A WITH CARON": "01CD",
        "LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE": "01FA",
        "LATIN SMALL LETTER A WITH DOUBLE GRAVE": "0201",
        "LATIN CAPITAL LETTER N WITH LONG RIGHT LEG": "0220",
        "LATIN CAPITAL LETTER E WITH STROKE": "0246",
        "LATIN CAPITAL LETTER Y WITH STROKE": "024E",
        "LATIN SMALL LETTER REVERSED OPEN E": "025C",
        "LATIN SMALL LETTER IOTA": "0269",
        "LATIN SMALL LETTER R WITH FISHHOOK": "027E",
        "LATIN SMALL LETTER T WITH RETROFLEX HOOK": "0288",
        "LATIN SMALL LETTER J WITH CROSSED-TAIL": "029D",
        "MODIFIER LETTER GRAVE ACCENT": "02CB",
        "DOT ABOVE": "02D9",
        "COMBINING BREVE": "0306",
        "COMBINING DOUBLE ACUTE ACCENT": "030B",
        "COMBINING RIGHT ARROWHEAD BELOW": "0355",
        "COMBINING DOUBLE INVERTED BREVE": "0361",
        "COMBINING LATIN SMALL LETTER O": "0366",
        "COMBINING LATIN SMALL LETTER D": "0369",
        "GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL": "037D",
        "GREEK CAPITAL LETTER YOT": "037F",
        "GREEK CAPITAL LETTER IOTA WITH TONOS": "038A",
        "GREEK CAPITAL LETTER OMICRON WITH TONOS": "038C",
        "GREEK CAPITAL LETTER LAMDA": "039B",
        "GREEK CAPITAL LETTER CHI": "03A7",
        "GREEK SMALL LETTER THETA": "03B8",
        "GREEK SMALL LETTER IOTA": "03B9",
        "GREEK SMALL LETTER XI": "03BE",
        "GREEK SMALL LETTER SIGMA": "03C3",
        "GREEK SMALL LETTER TAU": "03C4",
        "GREEK SMALL LETTER OMEGA": "03C9",
        "GREEK SMALL LETTER IOTA WITH DIALYTIKA": "03CA",
        "GREEK SMALL LETTER UPSILON WITH DIALYTIKA": "03CB",
        "GREEK SMALL LETTER OMICRON WITH TONOS": "03CC",
        "GREEK LUNATE EPSILON SYMBOL": "03F5",
        "CYRILLIC SMALL LETTER A": "0430",
        "CYRILLIC SMALL LETTER BE": "0431",
        "CYRILLIC SMALL LETTER GHE": "0433",
        "CYRILLIC THOUSANDS SIGN": "0482",
        "COMBINING CYRILLIC MILLIONS SIGN": "0489",
        "CYRILLIC SMALL LETTER EN WITH DESCENDER": "04A3",
        "CYRILLIC SMALL LETTER ES WITH DESCENDER": "04AB",
        "CYRILLIC CAPITAL LETTER EN WITH HOOK": "04C7",
        "CYRILLIC CAPITAL LETTER EM WITH TAIL": "04CD",
        "CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE": "04F2",
        "CYRILLIC CAPITAL LETTER KOMI DZJE": "0506",
        "CYRILLIC SMALL LETTER KOMI DZJE": "0507",
        "CYRILLIC CAPITAL LETTER EL WITH MIDDLE HOOK": "0520",
        "CYRILLIC CAPITAL LETTER EN WITH MIDDLE HOOK": "0522",
        "ARMENIAN CAPITAL LETTER MEN": "0544",
        "ARMENIAN SMALL LETTER NOW": "0576",
        "ARMENIAN SMALL LETTER TIWN": "057F",
        "HEBREW PUNCTUATION NUN HAFUKHA": "05C6",
        "ARABIC LETTER BEH": "0628",
        "ARABIC LETTER TEH MARBUTA": "0629",
        "ARABIC LETTER DAL": "062F",
        "ARABIC LETTER SEEN": "0633",
        "ARABIC LETTER ZAH": "0638",
        "ARABIC-INDIC DIGIT TWO": "0662",
        "ARABIC FIVE POINTED STAR": "066D",
        "ARABIC LETTER HIGH HAMZA": "0674",
        "ARABIC LETTER RREH": "0691",
        "ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA": "06D6",
        "ARABIC SMALL HIGH ROUNDED ZERO": "06DF",
        "ARABIC SMALL WAW": "06E5",
        "EXTENDED ARABIC-INDIC DIGIT NINE": "06F9",
        "SYRIAC END OF PARAGRAPH": "0700",
        "SYRIAC HORIZONTAL COLON": "0705",
        "SYRIAC LETTER TETH GARSHUNI": "071C",
        "SYRIAC LETTER SADHE": "0728",
        "SYRIAC LETTER PERSIAN DHALATH": "072F",
        "ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW AND TWO DOTS ABOVE": "0753",
        "ARABIC LETTER NOON WITH SMALL V": "0769",
        "ARABIC LETTER SEEN WITH INVERTED V": "077E",
        "THAANA LETTER NOONU": "0782",
        "NKO DIGIT EIGHT": "07C8",
        "NKO LETTER FA": "07DD",
        "NKO LETTER YA": "07E6",
        "NKO COMBINING LONG DESCENDING TONE": "07EE",
        "SAMARITAN VOWEL SIGN LONG I": "0829",
        "SAMARITAN MARK NEQUDAA": "082D",
        "SAMARITAN PUNCTUATION AFSAAQ": "0831",
        "MANDAIC LETTER IN": "084F",
        "ARABIC LETTER BEH WITH SMALL V BELOW": "08A0",
        "ARABIC LARGE CIRCLE BELOW": "08D1",
        "ARABIC CURLY FATHA": "08E4",
        "ARABIC TONE ONE DOT ABOVE": "08EA",
        "DEVANAGARI SIGN INVERTED CANDRABINDU": "0900",
        "DEVANAGARI LETTER JA": "091C",
        "DEVANAGARI LETTER GLOTTAL STOP": "097D",
        "BENGALI LETTER A": "0985",
        "BENGALI LETTER E": "098F",
        "BENGALI LETTER NGA": "0999",
        "BENGALI LETTER DDHA": "09A2",
        "BENGALI LETTER PHA": "09AB",
        "BENGALI LETTER RA": "09B0",
        "GURMUKHI LETTER CA": "0A1A",
        "GURMUKHI LETTER TTA": "0A1F",
        "GURMUKHI LETTER LLA": "0A33",
        "GURMUKHI LETTER VA": "0A35",
        "GURMUKHI TIPPI": "0A70",
        "GUJARATI LETTER I": "0A87",
        "GUJARATI LETTER U": "0A89",
        "GUJARATI LETTER DDA": "0AA1",
        "GUJARATI LETTER HA": "0AB9",
        "GUJARATI VOWEL SIGN VOCALIC L": "0AE2",
        "GUJARATI DIGIT SIX": "0AEC",
        "ORIYA SIGN VISARGA": "0B03",
        "ORIYA LETTER O": "0B13",
        "ORIYA LETTER JA": "0B1C",
        "ORIYA LETTER NNA": "0B23",
        "ORIYA VOWEL SIGN E": "0B47",
        "ORIYA AU LENGTH MARK": "0B57",
        "TAMIL LETTER AA": "0B86",
        "TAMIL LETTER O": "0B92",
        "TAMIL LETTER NGA": "0B99",
        "TAMIL AU LENGTH MARK": "0BD7",
        "TAMIL DIGIT FIVE": "0BEB",
        "TAMIL NUMBER TEN": "0BF0",
        "TELUGU LETTER NGA": "0C19",
        "TELUGU LETTER PA": "0C2A",
        "TELUGU SIGN NUKTA": "0C3C",
        "KANNADA LETTER II": "0C88",
        "KANNADA LETTER U": "0C89",
        "KANNADA LETTER KHA": "0C96",
        "KANNADA LETTER RRA": "0CB1",
        "KANNADA LETTER VA": "0CB5",
        "MALAYALAM SIGN CANDRABINDU": "0D01",
        "MALAYALAM LETTER I": "0D07",
        "MALAYALAM LETTER EE": "0D0F",
        "MALAYALAM LETTER GHA": "0D18",
        "MALAYALAM LETTER BHA": "0D2D",
        "MALAYALAM AU LENGTH MARK": "0D57",
        "MALAYALAM FRACTION ONE ONE-HUNDRED-AND-SIXTIETH": "0D58",
        "MALAYALAM LETTER VOCALIC LL": "0D61",
        "MALAYALAM DIGIT SEVEN": "0D6D",
        "SINHALA LETTER EYANNA": "0D91",
        "SINHALA LETTER ALPAPRAANA DDAYANNA": "0DA9",
        "SINHALA LETTER DANTAJA NAYANNA": "0DB1",
        "SINHALA LETTER ALPAPRAANA BAYANNA": "0DB6",
        "SINHALA LETTER MAHAAPRAANA BAYANNA": "0DB7",
        "SINHALA LETTER AMBA BAYANNA": "0DB9",
        "SINHALA LETTER RAYANNA": "0DBB",
        "SINHALA SIGN AL-LAKUNA": "0DCA",
        "SINHALA VOWEL SIGN KETTI IS-PILLA": "0DD2",
        "SINHALA VOWEL SIGN GAETTA-PILLA": "0DD8",
        "THAI CHARACTER SARA UE": "0E36",
        "THAI DIGIT TWO": "0E52",
        "THAI DIGIT NINE": "0E59",
        "LAO LETTER NYO": "0E8D",
        "LAO LETTER PO": "0E9B",
        "LAO LETTER MO": "0EA1",
        "LAO VOWEL SIGN MAI KAN": "0EB1",
        "LAO VOWEL SIGN AY": "0EC3",
        "LAO DIGIT ZERO": "0ED0",
        "LAO DIGIT EIGHT": "0ED8",
        "TIBETAN DIGIT ZERO": "0F20",
        "TIBETAN DIGIT FOUR": "0F24",
        "TIBETAN DIGIT HALF NINE": "0F32",
        "TIBETAN LETTER CA": "0F45",
        "TIBETAN LETTER JA": "0F47",
        "TIBETAN LETTER TTHA": "0F4B",
        "TIBETAN LETTER DHA": "0F52",
        "TIBETAN VOWEL SIGN U": "0F74",
        "TIBETAN VOWEL SIGN VOCALIC RR": "0F77",
        "TIBETAN VOWEL SIGN EE": "0F7B",
        "TIBETAN SIGN NYI ZLA NAA DA": "0F82",
        "TIBETAN SUBJOINED LETTER NA": "0FA3",
        "TIBETAN SUBJOINED LETTER SHA": "0FB4",
        "TIBETAN SYMBOL DRIL BU": "0FC4",
        "MYANMAR VOWEL SIGN E ABOVE": "1035",
        "MYANMAR LETTER GREAT SA": "103F",
        "MYANMAR LETTER SHAN DA": "107B",
        "GEORGIAN CAPITAL LETTER ZHAR": "10AF",
        "GEORGIAN CAPITAL LETTER KHAR": "10B5",
        "GEORGIAN CAPITAL LETTER JIL": "10BB",
        "GEORGIAN LETTER BAN": "10D1",
        "GEORGIAN LETTER KAN": "10D9",
        "GEORGIAN LETTER UN": "10E3",
        "GEORGIAN LETTER SHIN": "10E8",
        "HANGUL CHOSEONG IEUNG": "110B",
        "HANGUL CHOSEONG NIEUN-KIYEOK": "1113",
        "HANGUL CHOSEONG SSANGNIEUN": "1114",
        "HANGUL CHOSEONG PIEUP-PHIEUPH": "112A",
        "HANGUL CHOSEONG CHITUEUMCIEUC": "114E",
        "HANGUL CHOSEONG KAPYEOUNPHIEUPH": "1157",
        "HANGUL JUNGSEONG YA-YO": "1179",
        "HANGUL JONGSEONG MIEUM": "11B7",
        "HANGUL JONGSEONG SIOS": "11BA",
        "HANGUL JONGSEONG NIEUN-THIEUTH": "11C9",
        "HANGUL JONGSEONG RIEUL-PIEUP-HIEUH": "11D4",
        "HANGUL JONGSEONG MIEUM-PIEUP": "11DC",
        "ETHIOPIC SYLLABLE HHI": "1212",
        "ETHIOPIC SYLLABLE ME": "121D",
        "ETHIOPIC SYLLABLE SHAA": "123B",
        "ETHIOPIC SYLLABLE XI": "1282",
        "ETHIOPIC SYLLABLE NE": "1295",
        "ETHIOPIC SYLLABLE KEE": "12AC",
        "ETHIOPIC SYLLABLE KXO": "12BE",
        "ETHIOPIC SYLLABLE KXWE": "12C5",
        "ETHIOPIC SYLLABLE ZI": "12DA",
        "ETHIOPIC SYLLABLE ZHE": "12E5",
        "ETHIOPIC SYLLABLE YI": "12EA",
        "ETHIOPIC SYLLABLE YOA": "12EF",
        "ETHIOPIC SYLLABLE DWA": "12F7",
        "ETHIOPIC SYLLABLE JAA": "1303",
        "ETHIOPIC SYLLABLE TSE": "133D",
        "ETHIOPIC COMBINING VOWEL LENGTH MARK": "135E",
        "ETHIOPIC NUMBER FORTY": "1375",
        "ETHIOPIC SYLLABLE MWI": "1381",
        "ETHIOPIC TONAL MARK DERET": "1391",
        "CHEROKEE LETTER O": "13A3",
        "CHEROKEE LETTER HO": "13B0",
        "CHEROKEE LETTER NA": "13BE",
        "CHEROKEE LETTER TLI": "13DF",
        "CANADIAN SYLLABICS PAAI": "1430",
        "CANADIAN SYLLABICS PWE": "143A",
        "CANADIAN SYLLABICS TI": "144E",
        "CANADIAN SYLLABICS CII": "148C",
        "CANADIAN SYLLABICS CWA": "149C",
        "CANADIAN SYLLABICS MWI": "14AE",
        "CANADIAN SYLLABICS M": "14BB",
        "CANADIAN SYLLABICS LA": "14DA",
        "CANADIAN SYLLABICS SI": "14EF",
        "CANADIAN SYLLABICS SWE": "14F6",
        "CANADIAN SYLLABICS WEST-CREE SWE": "14F7",
        "CANADIAN SYLLABICS SWOO": "14FE",
        "CANADIAN SYLLABICS MOOSE-CREE SK": "1509",
        "CANADIAN SYLLABICS NASKAPI STWA": "150D",
        "CANADIAN SYLLABICS WEST-CREE FWAA": "155C",
        "CANADIAN SYLLABICS N-CREE THI": "1561",
        "CANADIAN SYLLABICS THII": "1562",
        "CANADIAN SYLLABICS TYO": "1572",
        "CANADIAN SYLLABICS TLHI": "1587",
        "CANADIAN SYLLABICS NGA": "1593",
        "CANADIAN SYLLABICS NGAA": "1594",
        "CANADIAN SYLLABICS NNG": "1596",
        "CANADIAN SYLLABICS LHI": "15A0",
        "CANADIAN SYLLABICS BLACKFOOT E": "15B0",
        "CANADIAN SYLLABICS BLACKFOOT NI": "15B9",
        "CANADIAN SYLLABICS SAYISI HE": "15C0",
        "CANADIAN SYLLABICS CARRIER HWO": "15D7",
        "CANADIAN SYLLABICS CARRIER GEE": "15F2",
        "CANADIAN SYLLABICS CARRIER YEE": "1611",
        "CANADIAN SYLLABICS CARRIER DLE": "162A",
        "CANADIAN SYLLABICS CARRIER LHO": "162F",
        "CANADIAN SYLLABICS CARRIER TLO": "163B",
        "CANADIAN SYLLABICS CARRIER SA": "1653",
        "CANADIAN SYLLABICS CHI SIGN": "166D",
        "CANADIAN SYLLABICS NNGOO": "1674",
        "OGHAM LETTER IODHADH": "1694",
        "RUNIC LETTER RAIDO RAD REID R": "16B1",
        "RUNIC LETTER LAUKAZ LAGU LOGR L": "16DA",
        "RUNIC LETTER ING": "16DD",
        "HANUNOO LETTER GA": "1724",
        "TAGBANWA LETTER DA": "1767",
        "TAGBANWA LETTER MA": "176B",
        "KHMER LETTER CHA": "1786",
        "KHMER LETTER HA": "17A0",
        "KHMER INDEPENDENT VOWEL LYY": "17AE",
        "KHMER VOWEL SIGN U": "17BB",
        "KHMER VOWEL SIGN YA": "17BF",
        "KHMER SIGN VIRIAM": "17D1",
        "KHMER SIGN CAMNUC PII KUUH": "17D6",
        "KHMER DIGIT EIGHT": "17E8",
        "KHMER SYMBOL LEK ATTAK PRAM-PII": "17F7",
        "MONGOLIAN NIRUGU": "180A",
        "MONGOLIAN DIGIT SIX": "1816",
        "MONGOLIAN LETTER OE": "1825",
        "MONGOLIAN LETTER SHA": "1831",
        "MONGOLIAN LETTER TODO O": "1846",
        "MONGOLIAN LETTER TODO DZA": "185C",
        "MONGOLIAN LETTER MANCHU RA": "1875",
        "MONGOLIAN LETTER MANCHU ALI GALI CA": "189C",
        "CANADIAN SYLLABICS OJIBWAY NWI": "18C7",
        "CANADIAN SYLLABICS WEST-CREE LAA": "18E2",
        "LIMBU LETTER JA": "1908",
        "LIMBU VOWEL SIGN A": "1920",
        "LIMBU SMALL LETTER TA": "1933",
        "LIMBU SIGN MUKPHRENG": "1939",
        "TAI LE LETTER XA": "1951",
        "NEW TAI LUE LETTER HIGH DA": "19A1",
        "NEW TAI LUE VOWEL SIGN U": "19B3",
        "NEW TAI LUE VOWEL SIGN AE": "19B6",
        "NEW TAI LUE VOWEL SIGN UEY": "19BF",
        "NEW TAI LUE THAM DIGIT ONE": "19DA",
        "BUGINESE LETTER VA": "1A13",
        "TAI THAM LETTER HIGH KHA": "1A21",
        "TAI THAM CONSONANT SIGN LOW PA": "1A5A",
        "TAI THAM VOWEL SIGN TALL AA": "1A64",
        "COMBINING PARENTHESES BELOW": "1ABD",
        "COMBINING TRIPLE ACUTE ACCENT": "1ACB",
        "COMBINING LATIN SMALL LETTER INSULAR G": "1ACC",
        "BALINESE LETTER ARCHAIC JNYA": "1B4C",
        "BALINESE CARIK PAMUNGKAH": "1B5D",
        "BALINESE MUSICAL SYMBOL COMBINING TEGEH": "1B6B",
        "BALINESE PANTI LANTANG": "1B7D",
        "SUNDANESE SIGN PANYECEK": "1B80",
        "SUNDANESE DIGIT FIVE": "1BB5",
        "BATAK LETTER WA": "1BCB",
        "BATAK VOWEL SIGN EE": "1BE9",
        "LEPCHA LETTER WA": "1C22",
        "LEPCHA CONSONANT SIGN T": "1C33",
        "OL CHIKI LETTER OH": "1C77",
        "OL CHIKI PUNCTUATION MUCAAD": "1C7E",
        "CYRILLIC SMALL LETTER WIDE ES": "1C83",
        "GEORGIAN MTAVRULI CAPITAL LETTER VIN": "1C95",
        "GEORGIAN MTAVRULI CAPITAL LETTER TAN": "1C97",
        "GEORGIAN MTAVRULI CAPITAL LETTER TURNED GAN": "1CB9",
        "SUNDANESE PUNCTUATION BINDU CAKRA": "1CC3",
        "VEDIC TONE ATHARVAVEDIC INDEPENDENT SVARITA": "1CE1",
        "VEDIC TONE RING ABOVE": "1CF8",
        "LATIN LETTER SMALL CAPITAL J": "1D0A",
        "LATIN LETTER SMALL CAPITAL OPEN O": "1D10",
        "MODIFIER LETTER CAPITAL BARRED B": "1D2F",
        "MODIFIER LETTER CAPITAL G": "1D33",
        "MODIFIER LETTER SMALL K": "1D4F",
        "LATIN SMALL LETTER R WITH PALATAL HOOK": "1D89",
        "MODIFIER LETTER SMALL ETH": "1D9E",
        "MODIFIER LETTER SMALL IOTA": "1DA5",
        "MODIFIER LETTER SMALL PHI": "1DB2",
        "COMBINING GRAVE-ACUTE-GRAVE": "1DC8",
        "COMBINING LATIN LETTER SMALL CAPITAL M": "1DDF",
        "COMBINING KAVYKA ABOVE RIGHT": "1DF6",
        "LATIN SMALL LETTER A WITH RING BELOW": "1E01",
        "LATIN CAPITAL LETTER G WITH MACRON": "1E20",
        "LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE": "1E2E",
        "LATIN CAPITAL LETTER O WITH MACRON AND ACUTE": "1E52",
        "LATIN SMALL LETTER T WITH LINE BELOW": "1E6F",
        "LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW": "1E77",
        "LATIN SMALL LETTER Z WITH DOT BELOW": "1E93",
        "LATIN CAPITAL LETTER A WITH BREVE AND ACUTE": "1EAE",
        "LATIN CAPITAL LETTER O WITH DOT BELOW": "1ECC",
        "LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE": "1ED0",
        "LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE": "1ED1",
        "LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE": "1ED6",
        "GREEK SMALL LETTER EPSILON WITH PSILI AND OXIA": "1F14",
        "GREEK CAPITAL LETTER EPSILON WITH DASIA AND VARIA": "1F1B",
        "GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA": "1F63",
        "GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA AND YPOGEGRAMMENI": "1FA4",
        "GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI": "1FA6",
        "GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI": "1FA7",
        "GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI": "1FB7",
        "GREEK CAPITAL LETTER ALPHA WITH VRACHY": "1FB8",
        "GREEK SMALL LETTER UPSILON WITH MACRON": "1FE1",
        "GREEK CAPITAL LETTER UPSILON WITH OXIA": "1FEB",
        "GREEK CAPITAL LETTER OMEGA WITH OXIA": "1FFB",
        "ZERO WIDTH SPACE": "200B",
        "FIGURE DASH": "2012",
        "LINE SEPARATOR": "2028",
        "RIGHT-TO-LEFT EMBEDDING": "202B",
        "DOUBLE PRIME": "2033",
        "INHIBIT ARABIC FORM SHAPING": "206C",
        "SUPERSCRIPT MINUS": "207B",
        "SUBSCRIPT FIVE": "2085",
        "DONG SIGN": "20AB",
        "PESO SIGN": "20B1",
        "LIVRE TOURNOIS SIGN": "20B6",
        "LARI SIGN": "20BE",
        "COMBINING ANTICLOCKWISE ARROW ABOVE": "20D4",
        "CENTRE LINE SYMBOL": "2104",
        "SCRIPT CAPITAL H": "210B",
        "SCRIPT CAPITAL I": "2110",
        "SCRIPT CAPITAL L": "2112",
        "SOUND RECORDING COPYRIGHT": "2117",
        "GIMEL SYMBOL": "2137",
        "DOUBLE-STRUCK N-ARY SUMMATION": "2140",
        "DOUBLE-STRUCK ITALIC SMALL E": "2147",
        "PER SIGN": "214C",
        "ROMAN NUMERAL FIFTY EARLY FORM": "2186",
        "LEFTWARDS ARROW": "2190",
        "SMALL CONTAINS AS MEMBER": "220D",
        "RIGHT ANGLE": "221F",
        "INTERSECTION": "2229",
        "CLOCKWISE CONTOUR INTEGRAL": "2232",
        "EQUIVALENT TO": "224D",
        "SUPERSET OF": "2283",
        "SQUARED MINUS": "229F",
        "MODELS": "22A7",
        "PRECEDES UNDER RELATION": "22B0",
        "LEFT SEMIDIRECT PRODUCT": "22CB",
        "GREATER-THAN WITH DOT": "22D7",
        "NOT NORMAL SUBGROUP OF OR EQUAL TO": "22EC",
        "DOWN RIGHT DIAGONAL ELLIPSIS": "22F1",
        "ELEMENT OF WITH DOT ABOVE": "22F5",
        "TOP RIGHT CROP": "230E",
        "TURNED NOT SIGN": "2319",
        "APL FUNCTIONAL SYMBOL QUAD BACKSLASH": "2342",
        "APL FUNCTIONAL SYMBOL JOT UNDERBAR": "235B",
        "APL FUNCTIONAL SYMBOL STAR DIAERESIS": "2363",
        "APL FUNCTIONAL SYMBOL IOTA": "2373",
        "APL FUNCTIONAL SYMBOL IOTA UNDERBAR": "2378",
        "APL FUNCTIONAL SYMBOL ALPHA": "237A",
        "INSERTION SYMBOL": "2380",
        "MONOSTABLE SYMBOL": "238D",
        "HYSTERESIS SYMBOL": "238E",
        "HORIZONTAL SCAN LINE-7": "23BC",
        "DENTISTRY SYMBOL LIGHT VERTICAL AND WAVE": "23C6",
        "SYMBOL FOR NULL": "2400",
        "SYMBOL FOR START OF TEXT": "2402",
        "SYMBOL FOR BELL": "2407",
        "SYMBOL FOR BACKSPACE": "2408",
        "SYMBOL FOR DELETE": "2421",
        "PARENTHESIZED DIGIT ONE": "2474",
        "PARENTHESIZED NUMBER ELEVEN": "247E",
        "CIRCLED LATIN CAPITAL LETTER H": "24BD",
        "CIRCLED LATIN CAPITAL LETTER K": "24C0",
        "NEGATIVE CIRCLED NUMBER FOURTEEN": "24EE",
        "BOX DRAWINGS UP HEAVY AND LEFT LIGHT": "251A",
        "BOX DRAWINGS LEFT HEAVY AND RIGHT UP LIGHT": "2535",
        "BOX DRAWINGS RIGHT HEAVY AND LEFT VERTICAL LIGHT": "253E",
        "BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY": "253F",
        "BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL": "254B",
        "BOX DRAWINGS UP SINGLE AND LEFT DOUBLE": "255B",
        "BOX DRAWINGS LIGHT ARC DOWN AND LEFT": "256E",
        "UPPER ONE EIGHTH BLOCK": "2594",
        "WHITE SQUARE": "25A1",
        "WHITE LEFT-POINTING SMALL TRIANGLE": "25C3",
        "INVERSE BULLET": "25D8",
        "LOWER LEFT TRIANGLE": "25FA",
        "BLACK LEFT POINTING INDEX": "261A",
        "BIOHAZARD SIGN": "2623",
        "TRIGRAM FOR LAKE": "2631",
        "RECYCLING SYMBOL FOR TYPE-4 PLASTICS": "2676",
        "SCALES": "2696",
        "OUTLINED WHITE STAR": "269D",
        "HIGH VOLTAGE SIGN": "26A1",
        "DOUBLED MALE SIGN": "26A3",
        "MEDIUM WHITE CIRCLE": "26AA",
        "COFFIN": "26B0",
        "SEMISEXTILE": "26BA",
        "SUN BEHIND CLOUD": "26C5",
        "BLACK TRUCK": "26DF",
        "CASTLE": "26EB",
        "GEAR WITHOUT HUB": "26ED",
        "WHITE NIB": "2711",
        "HEAVY ASTERISK": "2731",
        "BALLOON-SPOKED ASTERISK": "2749",
        "UPPER RIGHT SHADOWED WHITE SQUARE": "2752",
        "ROTATED HEAVY BLACK HEART BULLET": "2765",
        "DINGBAT NEGATIVE CIRCLED DIGIT TWO": "2777",
        "DINGBAT NEGATIVE CIRCLED DIGIT EIGHT": "277D",
        "DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FIVE": "278E",
        "HEAVY NORTH EAST ARROW": "279A",
        "HEAVY CONCAVE-POINTED BLACK RIGHTWARDS ARROW": "27A8",
        "HEAVY BLACK-FEATHERED NORTH EAST ARROW": "27B9",
        "WHITE TRIANGLE CONTAINING SMALL WHITE TRIANGLE": "27C1",
        "LONG RIGHTWARDS SQUIGGLE ARROW": "27FF",
        "BRAILLE PATTERN DOTS-1235": "2817",
        "BRAILLE PATTERN DOTS-56": "2830",
        "BRAILLE PATTERN DOTS-1457": "2859",
        "BRAILLE PATTERN DOTS-23567": "2876",
        "BRAILLE PATTERN DOTS-18": "2881",
        "BRAILLE PATTERN DOTS-48": "2888",
        "BRAILLE PATTERN DOTS-1458": "2899",
        "BRAILLE PATTERN DOTS-12458": "289B",
        "BRAILLE PATTERN DOTS-12468": "28AB",
        "BRAILLE PATTERN DOTS-2378": "28C6",
        "BRAILLE PATTERN DOTS-245678": "28FA",
        "RIGHTWARDS DOUBLE DASH ARROW": "290D",
        "RIGHTWARDS TWO-HEADED ARROW WITH TAIL": "2916",
        "LEFTWARDS ARROW WITH PLUS BELOW": "2946",
        "UPWARDS HARPOON WITH BARB LEFT TO BAR": "2958",
        "SUPERSET ABOVE LEFTWARDS ARROW": "297B",
        "TRIPLE VERTICAL BAR DELIMITER": "2980",
        "ANGLE WITH UNDERBAR": "29A4",
        "CIRCLED PARALLEL": "29B7",
        "CIRCLED REVERSE SOLIDUS": "29B8",
        "CIRCLED LESS-THAN": "29C0",
        "TRIANGLE WITH UNDERBAR": "29CB",
        "ERROR-BARRED WHITE CIRCLE": "29F2",
        "SOLIDUS WITH OVERBAR": "29F6",
        "QUADRUPLE INTEGRAL OPERATOR": "2A0C",
        "INTEGRAL AVERAGE WITH SLASH": "2A0F",
        "PLUS SIGN WITH BLACK TRIANGLE": "2A28",
        "UNION ABOVE INTERSECTION": "2A46",
        "TWO INTERSECTING LOGICAL AND": "2A55",
        "LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE RIGHT": "2A83",
        "GREATER-THAN AND SINGLE-LINE NOT EQUAL TO": "2A88",
        "LESS-THAN ABOVE SIMILAR ABOVE GREATER-THAN": "2A8F",
        "SIMILAR ABOVE LESS-THAN ABOVE EQUALS SIGN": "2A9F",
        "SUCCEEDS ABOVE NOT EQUAL TO": "2AB6",
        "SUBSET OF ABOVE TILDE OPERATOR": "2AC7",
        "SUPERSET OF ABOVE NOT EQUAL TO": "2ACC",
        "SUPERSET ABOVE SUPERSET": "2AD6",
        "DOUBLE VERTICAL BAR LEFT TURNSTILE": "2AE3",
        "BLACK SMALL LOZENGE": "2B2A",
        "LONG LEFTWARDS SQUIGGLE ARROW": "2B33",
        "LEFTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE": "2B3A",
        "WHITE RIGHT-POINTING PENTAGON": "2B54",
        "BENT ARROW POINTING DOWNWARDS THEN NORTH EAST": "2B5E",
        "OVERLAPPING WHITE SQUARES": "2BBA",
        "EQUALS SIGN WITH INFINITY BELOW": "2BF9",
        "GLAGOLITIC CAPITAL LETTER OTU": "2C19",
        "GLAGOLITIC CAPITAL LETTER SHA": "2C1E",
        "GLAGOLITIC CAPITAL LETTER IZHITSA": "2C2B",
        "GLAGOLITIC SMALL LETTER SMALL YUS": "2C54",
        "LATIN SMALL LETTER TAILLESS PHI": "2C77",
        "COPTIC CAPITAL LETTER EIE": "2C88",
        "COPTIC SMALL LETTER HATE": "2C8F",
        "COPTIC SMALL LETTER THETHE": "2C91",
        "COPTIC CAPITAL LETTER NI": "2C9A",
        "COPTIC SMALL LETTER UA": "2CA9",
        "COPTIC COMBINING SPIRITUS ASPER": "2CF0",
        "COPTIC OLD NUBIAN FULL STOP": "2CF9",
        "GEORGIAN SMALL LETTER IN": "2D08",
        "TIFINAGH LETTER TUAREG YAZH": "2D4C",
        "TIFINAGH LETTER YAM": "2D4E",
        "ETHIOPIC SYLLABLE DDOA": "2D8D",
        "ETHIOPIC SYLLABLE PHOA": "2D91",
        "COMBINING CYRILLIC LETTER ZHE": "2DE4",
        "COMBINING CYRILLIC LETTER YU": "2DFB",
        "COMBINING CYRILLIC LETTER IOTIFIED A": "2DFC",
        "LEFT DOTTED SUBSTITUTION BRACKET": "2E04",
        "RIGHT VERTICAL BAR WITH QUILL": "2E21",
        "WORD SEPARATOR MIDDLE DOT": "2E31",
        "RAISED DOT": "2E33",
        "DOUBLE HYPHEN": "2E40",
        "DOUBLE LOW-REVERSED-9 QUOTATION MARK": "2E42",
        "DASH WITH LEFT UPTURN": "2E43",
        "INVERTED LOW KAVYKA WITH KAVYKA ABOVE": "2E46",
        "CJK RADICAL SNOUT TWO": "2E95",
        "KANGXI RADICAL SUN": "2F47",
        "KANGXI RADICAL FUR": "2F51",
        "KANGXI RADICAL CLAW": "2F56",
        "KANGXI RADICAL PLOW": "2F7E",
        "KANGXI RADICAL CLOTHES": "2F90",
        "KANGXI RADICAL BADGER": "2F98",
        "IDEOGRAPHIC CLOSING MARK": "3006",
        "REVERSED DOUBLE PRIME QUOTATION MARK": "301D",
        "HANGZHOU NUMERAL THREE": "3023",
        "CIRCLED POSTAL MARK": "3036",
        "HIRAGANA LETTER KO": "3053",
        "HIRAGANA LETTER TA": "305F",
        "HIRAGANA LETTER NU": "306C",
        "HIRAGANA LETTER PU": "3077",
        "HIRAGANA LETTER HE": "3078",
        "HIRAGANA LETTER WO": "3092",
        "KATAKANA LETTER KA": "30AB",
        "KATAKANA LETTER DU": "30C5",
        "KATAKANA LETTER TE": "30C6",
        "KATAKANA LETTER HI": "30D2",
        "KATAKANA LETTER MI": "30DF",
        "KATAKANA LETTER WE": "30F1",
        "KATAKANA LETTER VI": "30F8",
        "HANGUL LETTER SSANGSIOS": "3146",
        "HANGUL LETTER THIEUTH": "314C",
        "HANGUL LETTER HIEUH": "314E",
        "HANGUL LETTER KAPYEOUNMIEUM": "3171",
        "HANGUL LETTER KAPYEOUNPHIEUPH": "3184",
        "BOPOMOFO LETTER KW": "31BD",
        "PARENTHESIZED HANGUL CHIEUCH": "3209",
        "PARENTHESIZED HANGUL KHIEUKH A": "3218",
        "PARENTHESIZED IDEOGRAPH TWO": "3221",
        "PARENTHESIZED IDEOGRAPH NINE": "3228",
        "CIRCLED HANGUL MIEUM": "3264",
        "CIRCLED HANGUL CIEUC": "3268",
        "CIRCLED IDEOGRAPH REST": "32A1",
        "CIRCLED IDEOGRAPH COPY": "32A2",
        "CIRCLED IDEOGRAPH NIGHT": "32B0",
        "CIRCLED NUMBER THIRTY SEVEN": "32B2",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR MARCH": "32C2",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR APRIL": "32C3",
        "CIRCLED KATAKANA SE": "32DD",
        "CIRCLED KATAKANA TO": "32E3",
        "CIRCLED KATAKANA YA": "32F3",
        "SQUARE ESUKUUDO": "3307",
        "SQUARE EEKAA": "3308",
        "SQUARE OOMU": "330A",
        "SQUARE KIROGURAMU": "3315",
        "SQUARE BIRU": "3331",
        "SQUARE MANSYON": "3347",
        "SQUARE YUAN": "3350",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THIRTEEN": "3365",
        "SQUARE MG": "338E",
        "SQUARE RAD": "33AD",
        "SQUARE MU S": "33B2",
        "SQUARE MV": "33B7",
        "SQUARE KK": "33CD",
        "IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVEN": "33E6",
        "HEXAGRAM FOR HOLDING TOGETHER": "4DC7",
        "<CJK Ideograph, Last>": "9FFF",
        "YI SYLLABLE PUO": "A044",
        "YI SYLLABLE BBA": "A060",
        "YI SYLLABLE BBOT": "A065",
        "YI SYLLABLE BBO": "A067",
        "YI SYLLABLE NBIP": "A079",
        "YI SYLLABLE NBA": "A07F",
        "YI SYLLABLE HMYR": "A0AD",
        "YI SYLLABLE MOP": "A0C0",
        "YI SYLLABLE VO": "A0F0",
        "YI SYLLABLE DA": "A109",
        "YI SYLLABLE TU": "A132",
        "YI SYLLABLE DDEX": "A148",
        "YI SYLLABLE HNIEX": "A16D",
        "YI SYLLABLE HLIP": "A19A",
        "YI SYLLABLE HLOP": "A1A7",
        "YI SYLLABLE HLUP": "A1AE",
        "YI SYLLABLE HLURX": "A1AF",
        "YI SYLLABLE HLY": "A1B3",
        "YI SYLLABLE LUOT": "A1C3",
        "YI SYLLABLE LYR": "A1D9",
        "YI SYLLABLE GA": "A1E4",
        "YI SYLLABLE GUP": "A1F5",
        "YI SYLLABLE GGOT": "A222",
        "YI SYLLABLE MGOX": "A23A",
        "YI SYLLABLE HXI": "A248",
        "YI SYLLABLE NGAP": "A263",
        "YI SYLLABLE HO": "A27B",
        "YI SYLLABLE WAX": "A281",
        "YI SYLLABLE WEP": "A28C",
        "YI SYLLABLE ZIT": "A28D",
        "YI SYLLABLE ZYP": "A2AB",
        "YI SYLLABLE CUP": "A2C7",
        "YI SYLLABLE ZZAT": "A2D8",
        "YI SYLLABLE ZZYRX": "A2EB",
        "YI SYLLABLE ZZYR": "A2EC",
        "YI SYLLABLE NZIT": "A2ED",
        "YI SYLLABLE SUR": "A323",
        "YI SYLLABLE SSOP": "A338",
        "YI SYLLABLE SSU": "A33E",
        "YI SYLLABLE CHU": "A372",
        "YI SYLLABLE NRYP": "A3A8",
        "YI SYLLABLE SHE": "A3B8",
        "YI SYLLABLE SHUR": "A3BF",
        "YI SYLLABLE RUOX": "A3CA",
        "YI SYLLABLE ROP": "A3D0",
        "YI SYLLABLE RYT": "A3DA",
        "YI SYLLABLE RYR": "A3DF",
        "YI SYLLABLE QOP": "A40B",
        "YI SYLLABLE NJIP": "A434",
        "YI SYLLABLE NJIET": "A435",
        "YI SYLLABLE NJOX": "A43C",
        "YI SYLLABLE NJYT": "A444",
        "YI SYLLABLE NYOX": "A456",
        "YI SYLLABLE NYU": "A45B",
        "YI RADICAL HXUO": "A49F",
        "YI RADICAL GA": "A4A1",
        "YI RADICAL DDUR": "A4A4",
        "YI RADICAL BUR": "A4A5",
        "YI RADICAL GOT": "A4B6",
        "LISU LETTER DA": "A4D3",
        "LISU LETTER TA": "A4D4",
        "LISU LETTER GA": "A4D6",
        "LISU LETTER NGA": "A4E5",
        "VAI SYLLABLE BEE": "A507",
        "VAI SYLLABLE THI": "A534",
        "VAI SYLLABLE MI": "A546",
        "VAI SYLLABLE MGBA": "A556",
        "VAI SYLLABLE JA": "A567",
        "VAI SYLLABLE WOON": "A575",
        "VAI SYLLABLE BHOO": "A577",
        "VAI SYLLABLE ZOO": "A589",
        "VAI SYLLABLE WU": "A599",
        "VAI SYLLABLE KPU": "A59F",
        "VAI SYLLABLE ZHU": "A5AF",
        "VAI SYLLABLE GU": "A5B6",
        "VAI SYLLABLE NGON": "A5BC",
        "VAI SYLLABLE BHO": "A5C2",
        "VAI SYLLABLE RO": "A5D0",
        "VAI SYLLABLE NDOLE KA": "A611",
        "CYRILLIC SMALL LETTER ZEMLYA": "A641",
        "CYRILLIC SMALL LETTER IOTIFIED YAT": "A653",
        "CYRILLIC CAPITAL LETTER SOFT EM": "A666",
        "CYRILLIC SMALL LETTER DOUBLE MONOCULAR O": "A66D",
        "COMBINING CYRILLIC THOUSAND MILLIONS SIGN": "A672",
        "COMBINING CYRILLIC LETTER OMEGA": "A67B",
        "CYRILLIC CAPITAL LETTER TWE": "A68C",
        "CYRILLIC SMALL LETTER TSSE": "A691",
        "BAMUM LETTER SHEUX": "A6B8",
        "BAMUM LETTER REUX": "A6D0",
        "BAMUM LETTER FOM": "A6D9",
        "BAMUM LETTER TEN": "A6EA",
        "BAMUM LETTER KOGHOM": "A6EF",
        "MODIFIER LETTER EXTRA-HIGH LEFT-STEM TONE BAR": "A712",
        "LATIN SMALL LETTER AU": "A737",
        "LATIN SMALL LETTER P WITH SQUIRREL TAIL": "A755",
        "LATIN SMALL LETTER ET": "A76B",
        "LATIN SMALL LETTER LUM": "A772",
        "LATIN CAPITAL LETTER INSULAR R": "A782",
        "LATIN CAPITAL LETTER F WITH STROKE": "A798",
        "LATIN SMALL LETTER GLOTTAL A": "A7BB",
        "LATIN EPIGRAPHIC LETTER REVERSED F": "A7FB",
        "SYLOTI NAGRI VOWEL SIGN A": "A823",
        "SYLOTI NAGRI POETRY MARK-1": "A828",
        "PHAGS-PA LETTER TSA": "A850",
        "SAURASHTRA LETTER VOCALIC R": "A888",
        "SAURASHTRA LETTER CA": "A897",
        "SAURASHTRA VOWEL SIGN AA": "A8B5",
        "COMBINING DEVANAGARI LETTER PA": "A8EE",
        "KAYAH LI LETTER NGA": "A90D",
        "KAYAH LI LETTER MA": "A917",
        "REJANG LETTER NA": "A935",
        "REJANG LETTER NYA": "A93B",
        "REJANG LETTER WA": "A940",
        "REJANG LETTER NGGA": "A943",
        "REJANG VOWEL SIGN EU": "A94D",
        "HANGUL CHOSEONG TIKEUT-CIEUC": "A963",
        "HANGUL CHOSEONG RIEUL-SSANGKIYEOK": "A965",
        "HANGUL CHOSEONG IEUNG-RIEUL": "A976",
        "JAVANESE LETTER A": "A984",
        "JAVANESE LETTER I": "A986",
        "JAVANESE LETTER KA MURDA": "A991",
        "JAVANESE LETTER NGA": "A994",
        "JAVANESE LETTER RA": "A9AB",
        "MYANMAR LETTER TAI LAING DA": "A9FB",
        "CHAM LETTER BHA": "AA1E",
        "CHAM DIGIT SIX": "AA56",
        "CHAM PUNCTUATION SPIRAL": "AA5C",
        "TAI VIET LETTER LOW THO": "AA96",
        "TAI VIET LETTER HIGH THO": "AA97",
        "TAI VIET TONE MAI EK": "AABF",
        "MEETEI MAYEK LETTER TTA": "AAE4",
        "ETHIOPIC SYLLABLE TTHE": "AB05",
        "LATIN SMALL LETTER BLACKLETTER O": "AB3D",
        "LATIN SMALL LETTER UI": "AB50",
        "LATIN SMALL LETTER X WITH LONG LEFT LEG": "AB57",
        "LATIN SMALL LETTER X WITH LONG LEFT LEG AND LOW RIGHT RING": "AB58",
        "CHEROKEE SMALL LETTER HI": "AB7F",
        "CHEROKEE SMALL LETTER QUI": "AB98",
        "CHEROKEE SMALL LETTER TA": "ABA4",
        "CHEROKEE SMALL LETTER TE": "ABA6",
        "CHEROKEE SMALL LETTER TLE": "ABAE",
        "HANGUL JUNGSEONG ARAEA-E": "D7C6",
        "HANGUL JONGSEONG KAPYEOUNRIEUL": "D7DD",
        "HANGUL JONGSEONG CIEUC-SSANGPIEUP": "D7F8",
        "HANGUL JONGSEONG PHIEUPH-SIOS": "D7FA",
        "CJK COMPATIBILITY IDEOGRAPH-F904": "F904",
        "CJK COMPATIBILITY IDEOGRAPH-F908": "F908",
        "CJK COMPATIBILITY IDEOGRAPH-F939": "F939",
        "CJK COMPATIBILITY IDEOGRAPH-F93A": "F93A",
        "CJK COMPATIBILITY IDEOGRAPH-F972": "F972",
        "CJK COMPATIBILITY IDEOGRAPH-F977": "F977",
        "CJK COMPATIBILITY IDEOGRAPH-F97D": "F97D",
        "CJK COMPATIBILITY IDEOGRAPH-F9B1": "F9B1",
        "CJK COMPATIBILITY IDEOGRAPH-F9B7": "F9B7",
        "CJK COMPATIBILITY IDEOGRAPH-F9C7": "F9C7",
        "CJK COMPATIBILITY IDEOGRAPH-F9FE": "F9FE",
        "CJK COMPATIBILITY IDEOGRAPH-FA0A": "FA0A",
        "CJK COMPATIBILITY IDEOGRAPH-FA11": "FA11",
        "CJK COMPATIBILITY IDEOGRAPH-FA21": "FA21",
        "CJK COMPATIBILITY IDEOGRAPH-FA24": "FA24",
        "CJK COMPATIBILITY IDEOGRAPH-FA2A": "FA2A",
        "CJK COMPATIBILITY IDEOGRAPH-FA2B": "FA2B",
        "CJK COMPATIBILITY IDEOGRAPH-FA34": "FA34",
        "CJK COMPATIBILITY IDEOGRAPH-FA4E": "FA4E",
        "CJK COMPATIBILITY IDEOGRAPH-FA7E": "FA7E",
        "CJK COMPATIBILITY IDEOGRAPH-FA8A": "FA8A",
        "CJK COMPATIBILITY IDEOGRAPH-FAAC": "FAAC",
        "ARMENIAN SMALL LIGATURE MEN INI": "FB15",
        "HEBREW LETTER ALTERNATIVE PLUS SIGN": "FB29",
        "HEBREW LETTER BET WITH RAFE": "FB4C",
        "ARABIC LETTER PEH MEDIAL FORM": "FB59",
        "ARABIC LETTER TTEH ISOLATED FORM": "FB66",
        "ARABIC LETTER DYEH MEDIAL FORM": "FB75",
        "ARABIC LETTER RREH ISOLATED FORM": "FB8C",
        "ARABIC LETTER U WITH HAMZA ABOVE ISOLATED FORM": "FBDD",
        "ARABIC LETTER KIRGHIZ YU FINAL FORM": "FBE3",
        "ARABIC LETTER E FINAL FORM": "FBE5",
        "ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE ISOLATED FORM": "FBEC",
        "ARABIC LIGATURE FEH WITH HAH ISOLATED FORM": "FC2E",
        "ARABIC LIGATURE FEH WITH YEH ISOLATED FORM": "FC32",
        "ARABIC LIGATURE MEEM WITH YEH ISOLATED FORM": "FC4A",
        "ARABIC LIGATURE YEH WITH JEEM ISOLATED FORM": "FC55",
        "ARABIC LIGATURE KAF WITH ALEF FINAL FORM": "FC80",
        "ARABIC LIGATURE LAM WITH YEH FINAL FORM": "FC87",
        "ARABIC LIGATURE YEH WITH YEH FINAL FORM": "FC96",
        "ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH KHAH INITIAL FORM": "FC99",
        "ARABIC LIGATURE SAD WITH MEEM INITIAL FORM": "FCB3",
        "ARABIC LIGATURE GHAIN WITH JEEM INITIAL FORM": "FCBC",
        "ARABIC LIGATURE QAF WITH HAH INITIAL FORM": "FCC2",
        "ARABIC LIGATURE MEEM WITH JEEM INITIAL FORM": "FCCE",
        "ARABIC LIGATURE MEEM WITH MEEM INITIAL FORM": "FCD1",
        "ARABIC LIGATURE SHEEN WITH ALEF MAKSURA ISOLATED FORM": "FCFD",
        "ARABIC LIGATURE SHEEN WITH YEH FINAL FORM": "FD1A",
        "ARABIC LIGATURE SAD WITH ALEF MAKSURA FINAL FORM": "FD21",
        "ARABIC LIGATURE DAD WITH ALEF MAKSURA FINAL FORM": "FD23",
        "ARABIC LIGATURE TAH WITH MEEM MEDIAL FORM": "FD3A",
        "ARABIC LIGATURE TEH WITH KHAH WITH MEEM INITIAL FORM": "FD54",
        "ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM": "FD62",
        "ARABIC LIGATURE SHEEN WITH HAH WITH MEEM FINAL FORM": "FD67",
        "ARABIC LIGATURE GHAIN WITH MEEM WITH YEH FINAL FORM": "FD7A",
        "ARABIC LIGATURE LAM WITH HAH WITH MEEM FINAL FORM": "FD80",
        "ARABIC LIGATURE LAM WITH KHAH WITH MEEM FINAL FORM": "FD85",
        "ARABIC LIGATURE TEH WITH KHAH WITH ALEF MAKSURA FINAL FORM": "FDA2",
        "VARIATION SELECTOR-3": "FE02",
        "VARIATION SELECTOR-10": "FE09",
        "PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET": "FE3D",
        "SMALL RIGHT TORTOISE SHELL BRACKET": "FE5E",
        "SMALL HYPHEN-MINUS": "FE63",
        "ARABIC LETTER ALEF WITH MADDA ABOVE ISOLATED FORM": "FE81",
        "ARABIC LETTER ALEF WITH HAMZA ABOVE FINAL FORM": "FE84",
        "FULLWIDTH RIGHT PARENTHESIS": "FF09",
        "FULLWIDTH LATIN CAPITAL LETTER R": "FF32",
        "FULLWIDTH RIGHT SQUARE BRACKET": "FF3D",
        "FULLWIDTH LATIN SMALL LETTER H": "FF48",
        "FULLWIDTH LATIN SMALL LETTER R": "FF52",
        "HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK": "FF70",
        "HALFWIDTH KATAKANA LETTER HU": "FF8C",
        "HALFWIDTH KATAKANA LETTER N": "FF9D",
        "HALFWIDTH KATAKANA VOICED SOUND MARK": "FF9E",
        "HALFWIDTH HANGUL LETTER RIEUL-PHIEUPH": "FFAF",
        "HALFWIDTH HANGUL LETTER RIEUL-HIEUH": "FFB0",
        "HALFWIDTH HANGUL LETTER O": "FFCC",
        "INTERLINEAR ANNOTATION TERMINATOR": "FFFB",
        "LINEAR B SYLLABLE B072 PE": "1001F",
        "LINEAR B MONOGRAM B128 KANAKO": "10094",
        "LINEAR B IDEOGRAM B191 HELMET": "100C3",
        "LINEAR B IDEOGRAM B236": "100CB",
        "LINEAR B IDEOGRAM VESSEL B221": "100F3",
        "AEGEAN NUMBER SEVENTY": "10116",
        "AEGEAN NUMBER SIXTY THOUSAND": "10130",
        "AEGEAN DRY MEASURE FIRST SUBUNIT": "1013C",
        "AEGEAN MEASURE THIRD SUBUNIT": "1013F",
        "GREEK ACROPHONIC ATTIC FIVE HUNDRED STATERS": "10153",
        "ROMAN SILIQUA SIGN": "10195",
        "PHAISTOS DISC SIGN WOMAN": "101D5",
        "PHAISTOS DISC SIGN BULLS LEG": "101EB",
        "PHAISTOS DISC SIGN ROSETTE": "101F5",
        "LYCIAN LETTER B": "10282",
        "LYCIAN LETTER I": "10286",
        "LYCIAN LETTER K": "1028B",
        "CARIAN LETTER U": "102B2",
        "CARIAN LETTER UUUU": "102BB",
        "COPTIC EPACT NUMBER TWENTY": "102EB",
        "GOTHIC LETTER THIUTH": "10338",
        "GOTHIC LETTER LAGUS": "1033B",
        "GOTHIC LETTER JER": "1033E",
        "OLD PERMIC LETTER CHERY": "10364",
        "OLD PERSIAN SIGN GA": "103A5",
        "OLD PERSIAN SIGN AURAMAZDAA": "103C8",
        "DESERET CAPITAL LETTER ENG": "10425",
        "OSAGE CAPITAL LETTER O": "104C2",
        "OSAGE SMALL LETTER HYA": "104E2",
        "ELBASAN LETTER I": "1050D",
        "ELBASAN LETTER VE": "10520",
        "CAUCASIAN ALBANIAN LETTER CAR": "10542",
        "CAUCASIAN ALBANIAN LETTER KAR": "10544",
        "CAUCASIAN ALBANIAN LETTER MAQ": "1054C",
        "CAUCASIAN ALBANIAN LETTER RAT": "10559",
        "CAUCASIAN ALBANIAN LETTER VEYZ": "1055B",
        "VITHKUQI SMALL LETTER PE": "105AF",
        "LINEAR A SIGN AB023": "10615",
        "LINEAR A SIGN AB039": "10622",
        "LINEAR A SIGN AB048": "10629",
        "LINEAR A SIGN AB070": "1063A",
        "LINEAR A SIGN AB079": "10640",
        "LINEAR A SIGN AB086": "10645",
        "LINEAR A SIGN A120B": "1064A",
        "LINEAR A SIGN AB131A": "1064D",
        "LINEAR A SIGN A401-VAS": "106A1",
        "LINEAR A SIGN A409-VAS": "106A9",
        "LINEAR A SIGN A506": "106B8",
        "LINEAR A SIGN A542": "106D5",
        "LINEAR A SIGN A583": "106F6",
        "LINEAR A SIGN A604": "10707",
        "LINEAR A SIGN A612": "1070D",
        "LINEAR A SIGN A616": "10711",
        "LINEAR A SIGN A659": "10731",
        "LINEAR A SIGN A661": "10733",
        "LINEAR A SIGN A709-6 L6": "1074C",
        "MODIFIER LETTER SMALL DEZH DIGRAPH": "1078A",
        "MODIFIER LETTER SMALL HENG WITH HOOK": "10797",
        "MODIFIER LETTER SMALL DOTLESS J WITH STROKE AND HOOK": "10798",
        "CYPRIOT SYLLABLE MI": "10816",
        "CYPRIOT SYLLABLE SE": "10829",
        "IMPERIAL ARAMAIC LETTER HE": "10844",
        "IMPERIAL ARAMAIC LETTER MEM": "1084C",
        "IMPERIAL ARAMAIC NUMBER TWENTY": "1085C",
        "PALMYRENE LETTER DALETH": "10863",
        "PALMYRENE LETTER SHIN": "10875",
        "PALMYRENE LETTER TAW": "10876",
        "PALMYRENE NUMBER ONE": "10879",
        "PHOENICIAN LETTER WAU": "10905",
        "LYDIAN LETTER I": "10926",
        "MEROITIC HIEROGLYPHIC LETTER O": "10983",
        "MEROITIC HIEROGLYPHIC LETTER BA": "10986",
        "MEROITIC HIEROGLYPHIC SYMBOL VIDJ-2": "1099F",
        "MEROITIC CURSIVE LETTER BA": "109A6",
        "MEROITIC CURSIVE LETTER KHA": "109AD",
        "KHAROSHTHI LETTER BA": "10A26",
        "KHAROSHTHI LETTER SSA": "10A2E",
        "KHAROSHTHI FRACTION ONE HALF": "10A48",
        "OLD SOUTH ARABIAN LETTER HETH": "10A62",
        "MANICHAEAN LETTER DALETH": "10AC5",
        "MANICHAEAN LETTER XOPH": "10ADF",
        "AVESTAN LETTER GHE": "10B16",
        "AVESTAN LETTER PE": "10B1E",
        "AVESTAN LETTER BHE": "10B21",
        "AVESTAN LETTER NGYE": "10B23",
        "AVESTAN LETTER NYE": "10B26",
        "AVESTAN LETTER HME": "10B29",
        "INSCRIPTIONAL PARTHIAN LETTER WAW": "10B45",
        "INSCRIPTIONAL PARTHIAN LETTER KAPH": "10B4A",
        "PSALTER PAHLAVI NUMBER ONE HUNDRED": "10BAF",
        "OLD TURKIC LETTER YENISEI ENC": "10C29",
        "OLD TURKIC LETTER ORKHON IC": "10C31",
        "OLD TURKIC LETTER ORKHON OT": "10C47",
        "OLD HUNGARIAN CAPITAL LETTER EF": "10C8C",
        "OLD HUNGARIAN CAPITAL LETTER EP": "10CA0",
        "OLD HUNGARIAN SMALL LETTER ER": "10CE2",
        "HANIFI ROHINGYA LETTER FA": "10D09",
        "HANIFI ROHINGYA LETTER SA": "10D0F",
        "YEZIDI LETTER VA": "10E9A",
        "YEZIDI LETTER LAM": "10EA0",
        "OLD SOGDIAN LETTER ZAYIN": "10F08",
        "OLD SOGDIAN LETTER ALTERNATE AYIN": "10F13",
        "OLD SOGDIAN LETTER RESH-AYIN-DALETH": "10F18",
        "OLD SOGDIAN NUMBER ONE HUNDRED": "10F25",
        "SOGDIAN LETTER ZAYIN": "10F35",
        "SOGDIAN LETTER LESH": "10F44",
        "SOGDIAN COMBINING TWO DOTS ABOVE": "10F49",
        "SOGDIAN NUMBER ONE HUNDRED": "10F54",
        "OLD UYGHUR LETTER ZAYIN": "10F74",
        "OLD UYGHUR LETTER TAW": "10F80",
        "CHORASMIAN LETTER SAMEKH": "10FBF",
        "ELYMAIC LETTER ZAYIN": "10FE6",
        "BRAHMI LETTER O": "11011",
        "KAITHI LETTER A": "11083",
        "KAITHI LETTER GHA": "11090",
        "KAITHI LETTER THA": "1109F",
        "KAITHI SIGN VIRAMA": "110B9",
        "KAITHI NUMBER SIGN": "110BD",
        "CHAKMA SIGN VISARGA": "11102",
        "CHAKMA LETTER PHAA": "1111C",
        "CHAKMA LETTER YYAA": "11120",
        "CHAKMA LETTER SAA": "11125",
        "CHAKMA O MARK": "11131",
        "MAHAJANI LETTER A": "11150",
        "MAHAJANI LETTER E": "11153",
        "MAHAJANI LETTER CHA": "1115A",
        "MAHAJANI LETTER NYA": "1115D",
        "MAHAJANI LETTER DDA": "11160",
        "KHOJKI LETTER AU": "11207",
        "KHOJKI LETTER GHA": "1120C",
        "KHOJKI LETTER THA": "1121A",
        "KHOJKI VOWEL SIGN AI": "11231",
        "KHOJKI SIGN ANUSVARA": "11234",
        "KHOJKI WORD SEPARATOR": "1123A",
        "MULTANI LETTER E": "11283",
        "MULTANI LETTER PHA": "1129C",
        "KHUDAWADI LETTER JJA": "112C3",
        "GRANTHA SIGN ANUSVARA": "11302",
        "GRANTHA LETTER VOCALIC R": "1130B",
        "GRANTHA LETTER THA": "11325",
        "GRANTHA AU LENGTH MARK": "11357",
        "NEWA LETTER DDHA": "1141D",
        "NEWA LETTER TA": "1141F",
        "NEWA SIGN VIRAMA": "11442",
        "NEWA SIDDHI": "1144A",
        "TIRHUTA LETTER E": "1148B",
        "TIRHUTA GVANG": "114C5",
        "SIDDHAM LETTER VOCALIC RR": "11587",
        "SIDDHAM LETTER BA": "115A4",
        "SIDDHAM LETTER HA": "115AE",
        "SIDDHAM VOWEL SIGN VOCALIC RR": "115B5",
        "SIDDHAM END OF TEXT MARK": "115C9",
        "SIDDHAM LETTER TWO-CIRCLE ALTERNATE II": "115DA",
        "MODI LETTER AI": "1160B",
        "MODI LETTER CHA": "11614",
        "MODI LETTER THA": "1161E",
        "MODI LETTER MA": "11626",
        "MODI VOWEL SIGN O": "1163B",
        "MODI SIGN HUVA": "11644",
        "TAKRI LETTER CA": "1168F",
        "AHOM DIGIT THREE": "11733",
        "DOGRA LETTER AA": "11801",
        "DOGRA LETTER JHA": "11812",
        "DOGRA LETTER BA": "11820",
        "DOGRA VOWEL SIGN E": "11833",
        "WARANG CITI CAPITAL LETTER HIYO": "118B9",
        "WARANG CITI SMALL LETTER AT": "118D5",
        "WARANG CITI SMALL LETTER AM": "118D6",
        "WARANG CITI NUMBER TEN": "118EA",
        "DIVES AKURU LETTER YA": "11925",
        "DIVES AKURU DIGIT THREE": "11953",
        "NANDINAGARI LETTER I": "119A2",
        "NANDINAGARI LETTER VOCALIC R": "119A6",
        "NANDINAGARI LETTER CA": "119B3",
        "NANDINAGARI LETTER JHA": "119B6",
        "NANDINAGARI LETTER NNA": "119BC",
        "NANDINAGARI LETTER PHA": "119C3",
        "NANDINAGARI LETTER MA": "119C6",
        "NANDINAGARI LETTER LLA": "119CF",
        "ZANABAZAR SQUARE VOWEL SIGN E": "11A04",
        "ZANABAZAR SQUARE CLOSING HEAD MARK": "11A40",
        "ZANABAZAR SQUARE INITIAL DOUBLE-LINED HEAD MARK": "11A45",
        "SOYOMBO VOWEL SIGN VOCALIC R": "11A59",
        "SOYOMBO LETTER TA": "11A6B",
        "SOYOMBO LETTER PHA": "11A71",
        "PAU CIN HAU LETTER CHA": "11AD4",
        "PAU CIN HAU SANDHI GLOTTAL STOP": "11AE7",
        "PAU CIN HAU MID-LEVEL TONE LONG FINAL": "11AF1",
        "DEVANAGARI SIGN EXTENDED BHALE WITH HOOK": "11B05",
        "DEVANAGARI SIGN MINDU": "11B09",
        "BHAIKSUKI LETTER VOCALIC RR": "11C07",
        "BHAIKSUKI LETTER CHA": "11C14",
        "BHAIKSUKI NUMBER SEVEN": "11C60",
        "MARCHEN LETTER ZHA": "11C86",
        "MASARAM GONDI LETTER TA": "11D1B",
        "MASARAM GONDI VOWEL SIGN AA": "11D31",
        "MASARAM GONDI VOWEL SIGN AI": "11D3C",
        "GUNJALA GONDI LETTER LLA": "11D7F",
        "GUNJALA GONDI LETTER NGA": "11D84",
        "GUNJALA GONDI VIRAMA": "11D97",
        "MAKASAR LETTER BA": "11EE4",
        "MAKASAR LETTER TA": "11EE6",
        "KAWI LETTER CA": "11F17",
        "KAWI LETTER DDHA": "11F1F",
        "KAWI PUNCTUATION DOT": "11F49",
        "TAMIL FRACTION THREE SIXTY-FOURTHS": "11FC7",
        "TAMIL FRACTION ONE TWENTIETH": "11FC8",
        "TAMIL TRADITIONAL NUMBER SIGN": "11FE9",
        "CUNEIFORM SIGN AB TIMES IMIN": "12011",
        "CUNEIFORM SIGN ASAL2": "12037",
        "CUNEIFORM SIGN DAG KISIM5 TIMES USH": "1206D",
        "CUNEIFORM SIGN DARA3": "12070",
        "CUNEIFORM SIGN E2 TIMES SAL": "12091",
        "CUNEIFORM SIGN GA2 TIMES SHE": "120E5",
        "CUNEIFORM SIGN GI4 OVER GI4": "12105",
        "CUNEIFORM SIGN GUD TIMES KUR": "12120",
        "CUNEIFORM SIGN HA": "12129",
        "CUNEIFORM SIGN HUB2 TIMES AN": "12139",
        "CUNEIFORM SIGN IDIM OVER IDIM BUR": "12143",
        "CUNEIFORM SIGN KA TIMES GA": "12162",
        "CUNEIFORM SIGN KA TIMES SHID": "12182",
        "CUNEIFORM SIGN KA2 CROSSING KA2": "1218E",
        "CUNEIFORM SIGN KAB": "1218F",
        "CUNEIFORM SIGN KAK": "12195",
        "CUNEIFORM SIGN KAK TIMES IGI GUNU": "12196",
        "CUNEIFORM SIGN KI TIMES UD": "121A3",
        "CUNEIFORM SIGN KISAL": "121A6",
        "CUNEIFORM SIGN LAGAB TIMES BI": "121C1",
        "CUNEIFORM SIGN LAGAB TIMES GA": "121C4",
        "CUNEIFORM SIGN LAGAB TIMES IM PLUS HA": "121CD",
        "CUNEIFORM SIGN LAGAB TIMES LUL": "121D7",
        "CUNEIFORM SIGN LU2 TIMES KAD2": "12205",
        "CUNEIFORM SIGN LU2 TIMES KAD3 PLUS ASH": "12207",
        "CUNEIFORM SIGN MA2": "12223",
        "CUNEIFORM SIGN MUSH TIMES A": "12233",
        "CUNEIFORM SIGN NE TIMES A": "12249",
        "CUNEIFORM SIGN NI TIMES E": "1224D",
        "CUNEIFORM SIGN NINDA2 TIMES GUD": "12256",
        "CUNEIFORM SIGN NUN OVER NUN": "1226A",
        "CUNEIFORM SIGN NUNUZ AB2 TIMES LA": "12274",
        "CUNEIFORM SIGN SANGA2": "122AB",
        "CUNEIFORM SIGN SHA3 TIMES U PLUS A": "122B6",
        "CUNEIFORM SIGN SHESH": "122C0",
        "CUNEIFORM SIGN SHESH2": "122C1",
        "CUNEIFORM SIGN SUR9": "122EA",
        "CUNEIFORM SIGN TE": "122FC",
        "CUNEIFORM SIGN URU TIMES ISH": "12344",
        "CUNEIFORM SIGN URUDA": "1234F",
        "CUNEIFORM SIGN GE22": "1237B",
        "CUNEIFORM SIGN TI2": "12397",
        "CUNEIFORM NUMERIC SIGN NINE ASH": "12407",
        "CUNEIFORM NUMERIC SIGN EIGHT DISH": "1240D",
        "CUNEIFORM NUMERIC SIGN EIGHT GESH2": "1241C",
        "CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU4": "12448",
        "CUNEIFORM NUMERIC SIGN ONE QUARTER ASH": "12460",
        "CUNEIFORM NUMERIC SIGN ELAMITE TWO THIRDS": "12466",
        "CUNEIFORM NUMERIC SIGN FIVE U VARIANT FORM": "1246A",
        "CUNEIFORM SIGN DA TIMES TAK4": "12488",
        "CUNEIFORM SIGN DUG TIMES MES": "124A3",
        "CUNEIFORM SIGN EZEN TIMES SU": "124B5",
        "CUNEIFORM SIGN GA2 TIMES DIM GUNU": "124B7",
        "CUNEIFORM SIGN GA2 TIMES GAR PLUS NE": "124BD",
        "CUNEIFORM SIGN GA2 TIMES KUSHU2 PLUS KASKAL": "124BF",
        "CUNEIFORM SIGN LAK-050": "124D9",
        "CUNEIFORM SIGN LAK-483": "124FA",
        "CUNEIFORM SIGN LU2 TIMES HAL": "1251B",
        "CUNEIFORM SIGN NINDA2 TIMES KESH2": "12526",
        "CUNEIFORM SIGN NINDA2 TIMES U": "1252A",
        "CUNEIFORM SIGN SHU2 PLUS DUG TIMES NI": "12536",
        "CUNEIFORM SIGN URU TIMES DARA3": "1253E",
        "CYPRO-MINOAN SIGN CM029": "12FA7",
        "CYPRO-MINOAN SIGN CM044": "12FB2",
        "CYPRO-MINOAN SIGN CM051": "12FB7",
        "CYPRO-MINOAN SIGN CM061": "12FC0",
        "CYPRO-MINOAN SIGN CM095": "12FE0",
        "CYPRO-MINOAN SIGN CM098": "12FE3",
        "CYPRO-MINOAN SIGN CM301": "12FF1",
        "EGYPTIAN HIEROGLYPH A002": "13001",
        "EGYPTIAN HIEROGLYPH A004": "13003",
        "EGYPTIAN HIEROGLYPH C001": "1305A",
        "EGYPTIAN HIEROGLYPH C015": "1306C",
        "EGYPTIAN HIEROGLYPH D003": "13078",
        "EGYPTIAN HIEROGLYPH D036": "1309D",
        "EGYPTIAN HIEROGLYPH D040": "130A1",
        "EGYPTIAN HIEROGLYPH D050F": "130B3",
        "EGYPTIAN HIEROGLYPH D055": "130BD",
        "EGYPTIAN HIEROGLYPH D067B": "130CB",
        "EGYPTIAN HIEROGLYPH D067E": "130CE",
        "EGYPTIAN HIEROGLYPH E001": "130D2",
        "EGYPTIAN HIEROGLYPH E020": "130E9",
        "EGYPTIAN HIEROGLYPH E032": "130F7",
        "EGYPTIAN HIEROGLYPH F002": "13100",
        "EGYPTIAN HIEROGLYPH F022": "13116",
        "EGYPTIAN HIEROGLYPH F028": "1311C",
        "EGYPTIAN HIEROGLYPH F031": "1311F",
        "EGYPTIAN HIEROGLYPH F049": "13137",
        "EGYPTIAN HIEROGLYPH G001": "1313F",
        "EGYPTIAN HIEROGLYPH G003": "13141",
        "EGYPTIAN HIEROGLYPH G010": "1314B",
        "EGYPTIAN HIEROGLYPH G027": "1315F",
        "EGYPTIAN HIEROGLYPH K002": "1319C",
        "EGYPTIAN HIEROGLYPH L007": "131AB",
        "EGYPTIAN HIEROGLYPH M010A": "131BA",
        "EGYPTIAN HIEROGLYPH M016": "131C9",
        "EGYPTIAN HIEROGLYPH M033A": "131E1",
        "EGYPTIAN HIEROGLYPH N019": "13203",
        "EGYPTIAN HIEROGLYPH NU009": "1323E",
        "EGYPTIAN HIEROGLYPH O011": "13265",
        "EGYPTIAN HIEROGLYPH O012": "13266",
        "EGYPTIAN HIEROGLYPH O017": "1326B",
        "EGYPTIAN HIEROGLYPH O036C": "13288",
        "EGYPTIAN HIEROGLYPH O050A": "13298",
        "EGYPTIAN HIEROGLYPH P002": "1329D",
        "EGYPTIAN HIEROGLYPH P011": "132A7",
        "EGYPTIAN HIEROGLYPH R012": "132BE",
        "EGYPTIAN HIEROGLYPH S005": "132D6",
        "EGYPTIAN HIEROGLYPH S006A": "132D8",
        "EGYPTIAN HIEROGLYPH S022": "132EB",
        "EGYPTIAN HIEROGLYPH T027": "13327",
        "EGYPTIAN HIEROGLYPH U018": "13346",
        "EGYPTIAN HIEROGLYPH U025": "1334E",
        "EGYPTIAN HIEROGLYPH U027": "13350",
        "EGYPTIAN HIEROGLYPH V001D": "13366",
        "EGYPTIAN HIEROGLYPH V005": "13370",
        "EGYPTIAN HIEROGLYPH V011": "13378",
        "EGYPTIAN HIEROGLYPH V031": "133A1",
        "EGYPTIAN HIEROGLYPH V031A": "133A2",
        "EGYPTIAN HIEROGLYPH W005": "133B4",
        "EGYPTIAN HIEROGLYPH W009A": "133B9",
        "EGYPTIAN HIEROGLYPH Y006": "133E1",
        "EGYPTIAN HIEROGLYPH Y008": "133E3",
        "EGYPTIAN HIEROGLYPH Z003A": "133EB",
        "EGYPTIAN HIEROGLYPH Z006": "133F1",
        "EGYPTIAN HIEROGLYPH Z010": "133F5",
        "EGYPTIAN HIEROGLYPH Z015": "133FA",
        "EGYPTIAN HIEROGLYPH Z015E": "133FF",
        "EGYPTIAN HIEROGLYPH AA023": "13425",
        "EGYPTIAN HIEROGLYPH AA032": "1342E",
        "EGYPTIAN HIEROGLYPH INSERT AT MIDDLE": "13439",
        "EGYPTIAN HIEROGLYPH BEGIN ENCLOSURE": "1343C",
        "EGYPTIAN HIEROGLYPH MODIFIER DAMAGED AT BOTTOM START AND TOP END": "1344C",
        "EGYPTIAN HIEROGLYPH MODIFIER DAMAGED AT START AND TOP": "1344D",
        "ANATOLIAN HIEROGLYPH A011": "1440B",
        "ANATOLIAN HIEROGLYPH A015": "1440F",
        "ANATOLIAN HIEROGLYPH A019": "14413",
        "ANATOLIAN HIEROGLYPH A023": "14417",
        "ANATOLIAN HIEROGLYPH A055": "1443D",
        "ANATOLIAN HIEROGLYPH A066A": "14449",
        "ANATOLIAN HIEROGLYPH A067": "1444C",
        "ANATOLIAN HIEROGLYPH A068": "1444D",
        "ANATOLIAN HIEROGLYPH A069": "1444E",
        "ANATOLIAN HIEROGLYPH A075": "14454",
        "ANATOLIAN HIEROGLYPH A083": "1445C",
        "ANATOLIAN HIEROGLYPH A099": "1446E",
        "ANATOLIAN HIEROGLYPH A104": "14476",
        "ANATOLIAN HIEROGLYPH A107A": "1447F",
        "ANATOLIAN HIEROGLYPH A125A": "14497",
        "ANATOLIAN HIEROGLYPH A137": "144A4",
        "ANATOLIAN HIEROGLYPH A143": "144AA",
        "ANATOLIAN HIEROGLYPH A145": "144AC",
        "ANATOLIAN HIEROGLYPH A150": "144B1",
        "ANATOLIAN HIEROGLYPH A155": "144B6",
        "ANATOLIAN HIEROGLYPH A191": "144DA",
        "ANATOLIAN HIEROGLYPH A200": "144E3",
        "ANATOLIAN HIEROGLYPH A202B": "144E7",
        "ANATOLIAN HIEROGLYPH A209": "144EF",
        "ANATOLIAN HIEROGLYPH A253": "1451F",
        "ANATOLIAN HIEROGLYPH A255": "14521",
        "ANATOLIAN HIEROGLYPH A261": "14527",
        "ANATOLIAN HIEROGLYPH A295": "1454C",
        "ANATOLIAN HIEROGLYPH A299A": "14551",
        "ANATOLIAN HIEROGLYPH A356": "14591",
        "ANATOLIAN HIEROGLYPH A359A": "14595",
        "ANATOLIAN HIEROGLYPH A375": "145A8",
        "ANATOLIAN HIEROGLYPH A380": "145AD",
        "ANATOLIAN HIEROGLYPH A383 RA OR RI": "145B1",
        "ANATOLIAN HIEROGLYPH A386": "145B5",
        "ANATOLIAN HIEROGLYPH A402": "145C6",
        "ANATOLIAN HIEROGLYPH A421": "145DA",
        "ANATOLIAN HIEROGLYPH A439": "145EC",
        "ANATOLIAN HIEROGLYPH A479": "14616",
        "ANATOLIAN HIEROGLYPH A518": "1463A",
        "BAMUM LETTER PHASE-A PON MFON PIPAEMBA": "16803",
        "BAMUM LETTER PHASE-A TU MAEMBA": "1680C",
        "BAMUM LETTER PHASE-A PUP": "1682D",
        "BAMUM LETTER PHASE-A SHUM": "16837",
        "BAMUM LETTER PHASE-A NYI": "1684F",
        "BAMUM LETTER PHASE-A VEE": "16852",
        "BAMUM LETTER PHASE-B LAANAE": "16871",
        "BAMUM LETTER PHASE-B MBEURI": "1687E",
        "BAMUM LETTER PHASE-C MBUE": "168A4",
        "BAMUM LETTER PHASE-C TITA YUE": "168AE",
        "BAMUM LETTER PHASE-C LAP": "168B6",
        "BAMUM LETTER PHASE-C MBIRIEEN": "168B7",
        "BAMUM LETTER PHASE-C NTEUNGBA": "168B9",
        "BAMUM LETTER PHASE-C RU": "168C3",
        "BAMUM LETTER PHASE-C PIN": "168EE",
        "BAMUM LETTER PHASE-D MEUT": "1690B",
        "BAMUM LETTER PHASE-D FEUFEUAET": "16914",
        "BAMUM LETTER PHASE-D RAEM": "16927",
        "BAMUM LETTER PHASE-D NTEUM": "16938",
        "BAMUM LETTER PHASE-D LEUM": "16944",
        "BAMUM LETTER PHASE-D LOQ": "1695F",
        "BAMUM LETTER PHASE-E SOM": "1696D",
        "BAMUM LETTER PHASE-E TAM": "16972",
        "BAMUM LETTER PHASE-E NSHIEE": "1697C",
        "BAMUM LETTER PHASE-E NGOP": "1697D",
        "BAMUM LETTER PHASE-E NGKEUX": "1697F",
        "BAMUM LETTER PHASE-E TAAQ": "169A1",
        "BAMUM LETTER PHASE-E NKOM": "169A8",
        "BAMUM LETTER PHASE-E MVI": "169C9",
        "BAMUM LETTER PHASE-E YEUX": "169DF",
        "BAMUM LETTER PHASE-E KI": "169FE",
        "BAMUM LETTER PHASE-F SHII": "16A13",
        "BAMUM LETTER PHASE-F FOM": "16A2B",
        "BAMUM LETTER PHASE-F MO": "16A33",
        "MRO LETTER OL": "16A4D",
        "MRO DIGIT ONE": "16A61",
        "TANGSA LETTER EQ": "16A7E",
        "TANGSA LETTER UIQ": "16A8E",
        "TANGSA LETTER UIX": "16A8F",
        "TANGSA DIGIT THREE": "16AC3",
        "BASSA VAH LETTER VU": "16AE3",
        "PAHAWH HMONG CONSONANT NKAU": "16B22",
        "PAHAWH HMONG SIGN XYEEM TOV": "16B3E",
        "PAHAWH HMONG SIGN IB YAM": "16B43",
        "PAHAWH HMONG NUMBER MILLIONS": "16B5E",
        "PAHAWH HMONG SIGN CIM TXWV CHWV": "16B75",
        "MEDEFAIDRIN CAPITAL LETTER F": "16E4A",
        "MEDEFAIDRIN CAPITAL LETTER N": "16E5B",
        "MIAO LETTER GHA": "16F28",
        "MIAO VOWEL SIGN AA": "16F55",
        "MIAO VOWEL SIGN IAN": "16F63",
        "MIAO LETTER TONE-3": "16F94",
        "TANGUT COMPONENT-002": "18801",
        "TANGUT COMPONENT-018": "18811",
        "TANGUT COMPONENT-024": "18817",
        "TANGUT COMPONENT-055": "18836",
        "TANGUT COMPONENT-070": "18845",
        "TANGUT COMPONENT-079": "1884E",
        "TANGUT COMPONENT-083": "18852",
        "TANGUT COMPONENT-091": "1885A",
        "TANGUT COMPONENT-116": "18873",
        "TANGUT COMPONENT-136": "18887",
        "TANGUT COMPONENT-147": "18892",
        "TANGUT COMPONENT-156": "1889B",
        "TANGUT COMPONENT-180": "188B3",
        "TANGUT COMPONENT-213": "188D4",
        "TANGUT COMPONENT-230": "188E5",
        "TANGUT COMPONENT-240": "188EF",
        "TANGUT COMPONENT-291": "18922",
        "TANGUT COMPONENT-296": "18927",
        "TANGUT COMPONENT-344": "18957",
        "TANGUT COMPONENT-348": "1895B",
        "TANGUT COMPONENT-360": "18967",
        "TANGUT COMPONENT-382": "1897D",
        "TANGUT COMPONENT-384": "1897F",
        "TANGUT COMPONENT-400": "1898F",
        "TANGUT COMPONENT-419": "189A2",
        "TANGUT COMPONENT-425": "189A8",
        "TANGUT COMPONENT-430": "189AD",
        "TANGUT COMPONENT-440": "189B7",
        "TANGUT COMPONENT-448": "189BF",
        "TANGUT COMPONENT-471": "189D6",
        "TANGUT COMPONENT-479": "189DE",
        "TANGUT COMPONENT-483": "189E2",
        "TANGUT COMPONENT-484": "189E3",
        "TANGUT COMPONENT-494": "189ED",
        "TANGUT COMPONENT-497": "189F0",
        "TANGUT COMPONENT-524": "18A0B",
        "TANGUT COMPONENT-588": "18A4B",
        "TANGUT COMPONENT-593": "18A50",
        "TANGUT COMPONENT-638": "18A7D",
        "TANGUT COMPONENT-644": "18A83",
        "TANGUT COMPONENT-661": "18A94",
        "TANGUT COMPONENT-681": "18AA8",
        "TANGUT COMPONENT-696": "18AB7",
        "TANGUT COMPONENT-727": "18AD6",
        "TANGUT COMPONENT-757": "18AF4",
        "KHITAN SMALL SCRIPT CHARACTER-18B0D": "18B0D",
        "KHITAN SMALL SCRIPT CHARACTER-18B0F": "18B0F",
        "KHITAN SMALL SCRIPT CHARACTER-18B2F": "18B2F",
        "KHITAN SMALL SCRIPT CHARACTER-18B33": "18B33",
        "KHITAN SMALL SCRIPT CHARACTER-18B59": "18B59",
        "KHITAN SMALL SCRIPT CHARACTER-18B68": "18B68",
        "KHITAN SMALL SCRIPT CHARACTER-18B69": "18B69",
        "KHITAN SMALL SCRIPT CHARACTER-18B7A": "18B7A",
        "KHITAN SMALL SCRIPT CHARACTER-18B7C": "18B7C",
        "KHITAN SMALL SCRIPT CHARACTER-18BC4": "18BC4",
        "KHITAN SMALL SCRIPT CHARACTER-18BCB": "18BCB",
        "KHITAN SMALL SCRIPT CHARACTER-18BCD": "18BCD",
        "KHITAN SMALL SCRIPT CHARACTER-18BDD": "18BDD",
        "KHITAN SMALL SCRIPT CHARACTER-18C10": "18C10",
        "KHITAN SMALL SCRIPT CHARACTER-18C1B": "18C1B",
        "KHITAN SMALL SCRIPT CHARACTER-18C1E": "18C1E",
        "KHITAN SMALL SCRIPT CHARACTER-18C24": "18C24",
        "KHITAN SMALL SCRIPT CHARACTER-18C4A": "18C4A",
        "KHITAN SMALL SCRIPT CHARACTER-18C51": "18C51",
        "KHITAN SMALL SCRIPT CHARACTER-18C5B": "18C5B",
        "KHITAN SMALL SCRIPT CHARACTER-18C5E": "18C5E",
        "KHITAN SMALL SCRIPT CHARACTER-18C72": "18C72",
        "KHITAN SMALL SCRIPT CHARACTER-18C9D": "18C9D",
        "KHITAN SMALL SCRIPT CHARACTER-18CAD": "18CAD",
        "KHITAN SMALL SCRIPT CHARACTER-18CB4": "18CB4",
        "HENTAIGANA LETTER KA-10": "1B020",
        "HENTAIGANA LETTER KU-6": "1B030",
        "HENTAIGANA LETTER TI-3": "1B064",
        "HENTAIGANA LETTER TI-7": "1B068",
        "HENTAIGANA LETTER TE-4": "1B071",
        "HENTAIGANA LETTER NU-3": "1B091",
        "HENTAIGANA LETTER NE-4": "1B095",
        "HENTAIGANA LETTER NO-1": "1B099",
        "HENTAIGANA LETTER HA-6": "1B0A3",
        "HENTAIGANA LETTER HA-10": "1B0A7",
        "HENTAIGANA LETTER HI-1": "1B0A9",
        "HENTAIGANA LETTER HI-5": "1B0AD",
        "HENTAIGANA LETTER HI-7": "1B0AF",
        "HENTAIGANA LETTER ME-1": "1B0D4",
        "KATAKANA LETTER SMALL WO": "1B166",
        "NUSHU CHARACTER-1B176": "1B176",
        "NUSHU CHARACTER-1B189": "1B189",
        "NUSHU CHARACTER-1B1AE": "1B1AE",
        "NUSHU CHARACTER-1B1C8": "1B1C8",
        "NUSHU CHARACTER-1B1E0": "1B1E0",
        "NUSHU CHARACTER-1B21B": "1B21B",
        "NUSHU CHARACTER-1B245": "1B245",
        "NUSHU CHARACTER-1B247": "1B247",
        "NUSHU CHARACTER-1B258": "1B258",
        "NUSHU CHARACTER-1B2BC": "1B2BC",
        "NUSHU CHARACTER-1B2F8": "1B2F8",
        "DUPLOYAN LETTER R": "1BC0B",
        "DUPLOYAN LETTER HL": "1BC16",
        "DUPLOYAN LETTER J N": "1BC30",
        "DUPLOYAN LETTER S K": "1BC3F",
        "DUPLOYAN LETTER SLOAN EE": "1BC4E",
        "DUPLOYAN LETTER VOCALIC M": "1BC6A",
        "DUPLOYAN AFFIX ATTACHED TANGENT": "1BC78",
        "DUPLOYAN AFFIX ATTACHED E HOOK": "1BC7A",
        "ZNAMENNY COMBINING MARK POVYSHE S KHOKHLOM ON LEFT": "1CF0A",
        "ZNAMENNY COMBINING MARK NIZKO S KRYZHEM ON RIGHT": "1CF0D",
        "ZNAMENNY COMBINING MARK ON": "1CF21",
        "ZNAMENNY COMBINING MARK DVOETOCHIE": "1CF3D",
        "ZNAMENNY NEUME ZAPYATAYA": "1CF5D",
        "ZNAMENNY NEUME SKAMEYTSA SVETLAYA": "1CF72",
        "ZNAMENNY NEUME STATYA ZAKRYTAYA S ZAPYATOY": "1CF8C",
        "ZNAMENNY NEUME STRELA MRACHNOTIKHAYA": "1CF93",
        "ZNAMENNY NEUME OSOKA SVETLAYA": "1CFB0",
        "ZNAMENNY NEUME STRELA KRYUKOVAYA": "1CFB5",
        "ZNAMENNY NEUME STRELA KRYUKOVAYA GROMNAYA": "1CFB9",
        "ZNAMENNY NEUME KUFISMA": "1CFBF",
        "BYZANTINE MUSICAL SYMBOL STAVROS APODEXIA": "1D01F",
        "BYZANTINE MUSICAL SYMBOL LEMOI": "1D02E",
        "BYZANTINE MUSICAL SYMBOL APESO EXO NEO": "1D033",
        "BYZANTINE MUSICAL SYMBOL PETASMA": "1D041",
        "BYZANTINE MUSICAL SYMBOL TROMIKOPARAKALESMA": "1D06E",
        "BYZANTINE MUSICAL SYMBOL KATAVASMA": "1D07A",
        "BYZANTINE MUSICAL SYMBOL KRATIMA NEO": "1D083",
        "BYZANTINE MUSICAL SYMBOL KORONIS": "1D089",
        "BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA ANO": "1D094",
        "BYZANTINE MUSICAL SYMBOL AGOGI ARGI": "1D09C",
        "BYZANTINE MUSICAL SYMBOL AGOGI METRIA": "1D09D",
        "BYZANTINE MUSICAL SYMBOL AGOGI GORGI": "1D09F",
        "BYZANTINE MUSICAL SYMBOL FTHORA NAOS ICHOS": "1D0BC",
        "BYZANTINE MUSICAL SYMBOL DIESIS APLI DYO DODEKATA": "1D0D0",
        "BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MIKRI": "1D0DA",
        "MUSICAL SYMBOL BREATH MARK": "1D112",
        "MUSICAL SYMBOL SIX-STRING FRETBOARD": "1D11C",
        "MUSICAL SYMBOL OTTAVA ALTA": "1D136",
        "MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH REST": "1D142",
        "MUSICAL SYMBOL COMBINING TREMOLO-2": "1D168",
        "MUSICAL SYMBOL BEGIN PHRASE": "1D179",
        "MUSICAL SYMBOL COMBINING MARCATO": "1D17F",
        "MUSICAL SYMBOL PIANO": "1D18F",
        "MUSICAL SYMBOL DAMP ALL": "1D1B5",
        "MUSICAL SYMBOL GREGORIAN C CLEF": "1D1D0",
        "MUSICAL SYMBOL PODATUS": "1D1D4",
        "MUSICAL SYMBOL PORRECTUS FLEXUS": "1D1DA",
        "GREEK VOCAL NOTATION SYMBOL-4": "1D203",
        "GREEK VOCAL NOTATION SYMBOL-15": "1D20E",
        "GREEK INSTRUMENTAL NOTATION SYMBOL-38": "1D234",
        "GREEK INSTRUMENTAL NOTATION SYMBOL-39": "1D235",
        "KAKTOVIK NUMERAL EIGHTEEN": "1D2D2",
        "MAYAN NUMERAL FIFTEEN": "1D2EF",
        "TETRAGRAM FOR BRANCHING OUT": "1D30E",
        "TETRAGRAM FOR PENETRATION": "1D313",
        "TETRAGRAM FOR REACH": "1D314",
        "TETRAGRAM FOR CLOSENESS": "1D326",
        "TETRAGRAM FOR LAW OR MODEL": "1D32D",
        "TETRAGRAM FOR DEPARTURE": "1D347",
        "MATHEMATICAL BOLD CAPITAL A": "1D400",
        "MATHEMATICAL BOLD CAPITAL Z": "1D419",
        "MATHEMATICAL ITALIC CAPITAL E": "1D438",
        "MATHEMATICAL ITALIC CAPITAL J": "1D43D",
        "MATHEMATICAL BOLD ITALIC CAPITAL Z": "1D481",
        "MATHEMATICAL BOLD ITALIC SMALL J": "1D48B",
        "MATHEMATICAL BOLD ITALIC SMALL U": "1D496",
        "MATHEMATICAL BOLD ITALIC SMALL V": "1D497",
        "MATHEMATICAL BOLD ITALIC SMALL Z": "1D49B",
        "MATHEMATICAL SCRIPT SMALL A": "1D4B6",
        "MATHEMATICAL SCRIPT SMALL H": "1D4BD",
        "MATHEMATICAL BOLD SCRIPT CAPITAL B": "1D4D1",
        "MATHEMATICAL BOLD SCRIPT SMALL H": "1D4F1",
        "MATHEMATICAL FRAKTUR SMALL C": "1D520",
        "MATHEMATICAL DOUBLE-STRUCK SMALL C": "1D554",
        "MATHEMATICAL DOUBLE-STRUCK SMALL K": "1D55C",
        "MATHEMATICAL DOUBLE-STRUCK SMALL U": "1D566",
        "MATHEMATICAL BOLD FRAKTUR CAPITAL A": "1D56C",
        "MATHEMATICAL BOLD FRAKTUR CAPITAL H": "1D573",
        "MATHEMATICAL BOLD FRAKTUR CAPITAL O": "1D57A",
        "MATHEMATICAL BOLD FRAKTUR CAPITAL Z": "1D585",
        "MATHEMATICAL BOLD FRAKTUR SMALL X": "1D59D",
        "MATHEMATICAL SANS-SERIF CAPITAL D": "1D5A3",
        "MATHEMATICAL SANS-SERIF SMALL J": "1D5C3",
        "MATHEMATICAL SANS-SERIF ITALIC CAPITAL Q": "1D618",
        "MATHEMATICAL SANS-SERIF ITALIC CAPITAL Y": "1D620",
        "MATHEMATICAL SANS-SERIF ITALIC SMALL F": "1D627",
        "MATHEMATICAL SANS-SERIF ITALIC SMALL W": "1D638",
        "MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL D": "1D63F",
        "MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL N": "1D663",
        "MATHEMATICAL MONOSPACE CAPITAL H": "1D677",
        "MATHEMATICAL MONOSPACE CAPITAL N": "1D67D",
        "MATHEMATICAL MONOSPACE CAPITAL Q": "1D680",
        "MATHEMATICAL MONOSPACE SMALL W": "1D6A0",
        "MATHEMATICAL BOLD CAPITAL ALPHA": "1D6A8",
        "MATHEMATICAL BOLD CAPITAL TAU": "1D6BB",
        "MATHEMATICAL BOLD SMALL ETA": "1D6C8",
        "MATHEMATICAL BOLD PI SYMBOL": "1D6E1",
        "MATHEMATICAL ITALIC CAPITAL RHO": "1D6F2",
        "MATHEMATICAL ITALIC SMALL CHI": "1D712",
        "MATHEMATICAL SANS-SERIF BOLD CAPITAL BETA": "1D757",
        "MATHEMATICAL SANS-SERIF BOLD SMALL PHI": "1D785",
        "MATHEMATICAL SANS-SERIF BOLD PHI SYMBOL": "1D78D",
        "MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA": "1D797",
        "MATHEMATICAL BOLD DIGIT TWO": "1D7D0",
        "MATHEMATICAL DOUBLE-STRUCK DIGIT SEVEN": "1D7DF",
        "SIGNWRITING HAND-FIST INDEX MIDDLE RAISED KNUCKLES": "1D811",
        "SIGNWRITING HAND-FIST MIDDLE BENT OVER INDEX": "1D81C",
        "SIGNWRITING HAND-CIRCLE INDEX MIDDLE THUMB": "1D81F",
        "SIGNWRITING HAND-FIST MIDDLE THUMB ANGLED OUT INDEX UP": "1D840",
        "SIGNWRITING HAND-FIST INDEX THUMB HOOKED MIDDLE HINGED": "1D843",
        "SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD": "1D84C",
        "SIGNWRITING HAND-FLAT HEEL THUMB SIDE": "1D85E",
        "SIGNWRITING HAND-FLAT SPLIT CENTRE THUMB SIDE": "1D863",
        "SIGNWRITING HAND-CUP OPEN NO THUMB": "1D870",
        "SIGNWRITING HAND-FIST INDEX MIDDLE RING CONJOINED": "1D88C",
        "SIGNWRITING HAND-HINGE INDEX MIDDLE RING CONJOINED": "1D88D",
        "SIGNWRITING HAND-FIST RING LITTLE": "1D8B0",
        "SIGNWRITING HAND-CUP INDEX RING LITTLE": "1D8C0",
        "SIGNWRITING HAND-ANGLE INDEX THUMB IN": "1D8F3",
        "SIGNWRITING HAND-FIST THUMB OVER FOUR RAISED KNUCKLES": "1D902",
        "SIGNWRITING FLICK LARGE SINGLE": "1D91B",
        "SIGNWRITING MOVEMENT-WALLPLANE TRIPLE ALTERNATING WRIST FLEX": "1D937",
        "SIGNWRITING MOVEMENT-WALLPLANE PEAKS SMALL": "1D948",
        "SIGNWRITING MOVEMENT-DIAGONAL BETWEEN AWAY MEDIUM": "1D95E",
        "SIGNWRITING TRAVEL-FLOORPLANE ROTATION-WALLPLANE ALTERNATING": "1D986",
        "SIGNWRITING MOVEMENT-WALLPLANE HUMP SMALL": "1D992",
        "SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE DOUBLE SMALL": "1D999",
        "SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE TRIPLE SMALL": "1D99C",
        "SIGNWRITING MOVEMENT-WALLPLANE WAVE HITTING FRONT WALL": "1D9A9",
        "SIGNWRITING ROTATION-WALLPLANE SINGLE HITTING FRONT WALL": "1D9AA",
        "SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING CEILING LARGE TRIPLE": "1D9BC",
        "SIGNWRITING ROTATION-FLOORPLANE SINGLE HITTING FLOOR": "1D9D2",
        "SIGNWRITING MOVEMENT-FLOORPLANE ARM CIRCLE HITTING WALL MEDIUM DOUBLE": "1D9EB",
        "SIGNWRITING EYES OPEN": "1DA14",
        "SIGNWRITING EYES HALF OPEN": "1DA19",
        "SIGNWRITING EYEGAZE-WALLPLANE CIRCLING": "1DA29",
        "SIGNWRITING EARS": "1DA30",
        "SIGNWRITING NOSE CONTACT": "1DA32",
        "SIGNWRITING MOUTH SMILE OPEN": "1DA40",
        "SIGNWRITING MOUTH OPEN OVAL": "1DA47",
        "SIGNWRITING MOUTH TENSE SUCKED": "1DA52",
        "SIGNWRITING LIP LOWER OVER UPPER": "1DA54",
        "SIGNWRITING TEETH MOVEMENT": "1DA62",
        "SIGNWRITING LIMB LENGTH-6": "1DA7C",
        "SIGNWRITING ROTATION MODIFIER-7": "1DAA6",
        "SIGNWRITING ROTATION MODIFIER-11": "1DAAA",
        "SIGNWRITING ROTATION MODIFIER-13": "1DAAC",
        "LATIN SMALL LETTER ESH WITH DOUBLE BAR AND CURL": "1DF0C",
        "LATIN SMALL LETTER DEZH DIGRAPH WITH RETROFLEX HOOK": "1DF19",
        "COMBINING GLAGOLITIC LETTER LJUDIJE": "1E00E",
        "CYRILLIC SUBSCRIPT SMALL LETTER I": "1E059",
        "CYRILLIC SUBSCRIPT SMALL LETTER U": "1E05F",
        "CYRILLIC SUBSCRIPT SMALL LETTER HA": "1E061",
        "NYIAKENG PUACHUE HMONG LETTER ZA": "1E10B",
        "NYIAKENG PUACHUE HMONG LETTER I": "1E126",
        "NYIAKENG PUACHUE HMONG DIGIT THREE": "1E143",
        "TOTO LETTER BREATHY AE": "1E2AC",
        "WANCHO LETTER E": "1E2DB",
        "ETHIOPIC SYLLABLE GURAGE MWEE": "1E7EE",
        "MENDE KIKAKUI SYLLABLE M004 WI": "1E808",
        "MENDE KIKAKUI SYLLABLE M073 LE": "1E83A",
        "MENDE KIKAKUI SYLLABLE M160 JOO": "1E850",
        "MENDE KIKAKUI SYLLABLE M175 LONG JO": "1E852",
        "MENDE KIKAKUI SYLLABLE M038 NAN": "1E864",
        "MENDE KIKAKUI SYLLABLE M047 MBEE": "1E896",
        "MENDE KIKAKUI SYLLABLE M072 MBE": "1E898",
        "MENDE KIKAKUI SYLLABLE M191 NDEE": "1E8B1",
        "MENDE KIKAKUI SYLLABLE M185 VA": "1E8BA",
        "MENDE KIKAKUI SYLLABLE M173 VEE": "1E8BC",
        "MENDE KIKAKUI DIGIT NINE": "1E8CF",
        "MENDE KIKAKUI COMBINING NUMBER THOUSANDS": "1E8D3",
        "ADLAM DIGIT ZERO": "1E950",
        "INDIC SIYAQ NUMBER EIGHTY": "1EC81",
        "INDIC SIYAQ NUMBER SIX HUNDRED": "1EC88",
        "INDIC SIYAQ NUMBER LAKHAN": "1EC9F",
        "INDIC SIYAQ FRACTION ONE QUARTER": "1ECAD",
        "OTTOMAN SIYAQ NUMBER FOUR": "1ED04",
        "OTTOMAN SIYAQ NUMBER TWENTY": "1ED0B",
        "OTTOMAN SIYAQ NUMBER FIVE HUNDRED": "1ED17",
        "OTTOMAN SIYAQ MARRATAN": "1ED2E",
        "ARABIC MATHEMATICAL NOON": "1EE0D",
        "ARABIC MATHEMATICAL SHEEN": "1EE14",
        "ARABIC MATHEMATICAL INITIAL NOON": "1EE2D",
        "ARABIC MATHEMATICAL TAILED DAD": "1EE59",
        "ARABIC MATHEMATICAL LOOPED THEH": "1EE96",
        "ARABIC MATHEMATICAL DOUBLE-STRUCK ZAIN": "1EEA6",
        "MAHJONG TILE NINE OF BAMBOOS": "1F018",
        "MAHJONG TILE EIGHT OF CIRCLES": "1F020",
        "MAHJONG TILE AUTUMN": "1F028",
        "DOMINO TILE HORIZONTAL-00-00": "1F031",
        "DOMINO TILE HORIZONTAL-00-06": "1F037",
        "DOMINO TILE HORIZONTAL-01-02": "1F03A",
        "DOMINO TILE HORIZONTAL-01-05": "1F03D",
        "DOMINO TILE VERTICAL-01-04": "1F06E",
        "PLAYING CARD WHITE JOKER": "1F0DF",
        "PARENTHESIZED LATIN CAPITAL LETTER D": "1F113",
        "PARENTHESIZED LATIN CAPITAL LETTER L": "1F11B",
        "PARENTHESIZED LATIN CAPITAL LETTER M": "1F11C",
        "SQUARED LATIN CAPITAL LETTER E": "1F134",
        "NEGATIVE CIRCLED LATIN CAPITAL LETTER S": "1F162",
        "NEGATIVE SQUARED LATIN CAPITAL LETTER F": "1F175",
        "NEGATIVE SQUARED LATIN CAPITAL LETTER L": "1F17B",
        "NEGATIVE SQUARED LATIN CAPITAL LETTER T": "1F183",
        "NEGATIVE SQUARED LATIN CAPITAL LETTER V": "1F185",
        "SQUARED SEVEN POINT ONE": "1F1A1",
        "REGIONAL INDICATOR SYMBOL LETTER G": "1F1EC",
        "SQUARED KATAKANA KOKO": "1F201",
        "TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-6253": "1F245",
        "ROUNDED SYMBOL FOR SHUANGXI": "1F264",
        "SUNSET OVER BUILDINGS": "1F307",
        "BLACK DROPLET": "1F322",
        "BLOSSOM": "1F33C",
        "MUSHROOM": "1F344",
        "STEAMING BOWL": "1F35C",
        "FRIED SHRIMP": "1F364",
        "TEACUP WITHOUT HANDLE": "1F375",
        "CLINKING BEER MUGS": "1F37B",
        "HEART WITH TIP ON THE LEFT": "1F394",
        "REMINDER RIBBON": "1F397",
        "BEAMED ASCENDING MUSICAL NOTES": "1F39C",
        "MOVIE CAMERA": "1F3A5",
        "CINEMA": "1F3A6",
        "BASKETBALL AND HOOP": "1F3C0",
        "AMPHORA": "1F3FA",
        "DOLPHIN": "1F42C",
        "DOG FACE": "1F436",
        "WAVING HAND SIGN": "1F44B",
        "POUCH": "1F45D",
        "POLICE OFFICER": "1F46E",
        "EXTRATERRESTRIAL ALIEN": "1F47D",
        "SPARKLING HEART": "1F496",
        "MONEY BAG": "1F4B0",
        "HEAVY DOLLAR SIGN": "1F4B2",
        "PERSONAL COMPUTER": "1F4BB",
        "CLOSED BOOK": "1F4D5",
        "PAGER": "1F4DF",
        "VIDEO CAMERA": "1F4F9",
        "BATTERY": "1F50B",
        "ON WITH EXCLAMATION MARK WITH LEFT RIGHT ARROW ABOVE": "1F51B",
        "CRYSTAL BALL": "1F52E",
        "NOTCHED RIGHT SEMICIRCLE WITH THREE DOTS": "1F544",
        "KAABA": "1F54B",
        "SIDEWAYS WHITE DOWN POINTING INDEX": "1F59F",
        "OLD KEY": "1F5DD",
        "SPEAKING HEAD IN SILHOUETTE": "1F5E3",
        "TWO SPEECH BUBBLES": "1F5EA",
        "WORLD MAP": "1F5FA",
        "SMILING FACE WITH OPEN MOUTH AND TIGHTLY-CLOSED EYES": "1F606",
        "SMILING FACE WITH SUNGLASSES": "1F60E",
        "WEARY CAT FACE": "1F640",
        "TURNED SOUTH EAST POINTING LEAF": "1F657",
        "SOLID QUILT SQUARE ORNAMENT IN BLACK SQUARE": "1F66B",
        "RIGHTWARDS ROCKET": "1F66E",
        "ONCOMING TAXI": "1F696",
        "ONCOMING AUTOMOBILE": "1F698",
        "SUSPENSION RAILWAY": "1F69F",
        "AIRPLANE DEPARTURE": "1F6EB",
        "DIESEL LOCOMOTIVE": "1F6F2",
        "ALCHEMICAL SYMBOL FOR IRON ORE": "1F71C",
        "ALCHEMICAL SYMBOL FOR ANTIMONY ORE": "1F72B",
        "ALCHEMICAL SYMBOL FOR TARTAR": "1F73F",
        "ALCHEMICAL SYMBOL FOR SCEPTER OF JOVE": "1F74F",
        "ALCHEMICAL SYMBOL FOR LODESTONE": "1F753",
        "ALCHEMICAL SYMBOL FOR HOUR": "1F76E",
        "BLACK TINY SQUARE": "1F78C",
        "WHITE SQUARE CONTAINING BLACK VERY SMALL SQUARE": "1F794",
        "MEDIUM SALTIRE": "1F7AA",
        "HEAVY SALTIRE": "1F7AC",
        "VERY HEAVY SIX SPOKED ASTERISK": "1F7B9",
        "MEDIUM SIX POINTED BLACK STAR": "1F7CB",
        "VERY HEAVY EIGHT POINTED BLACK STAR": "1F7D0",
        "LARGE GREEN CIRCLE": "1F7E2",
        "LARGE BROWN CIRCLE": "1F7E4",
        "RIGHTWARDS ARROW WITH LARGE TRIANGLE ARROWHEAD": "1F80A",
        "LEFTWARDS FINGER-POST ARROW": "1F834",
        "DOWNWARDS SQUARED ARROW": "1F83B",
        "UPWARDS HEAVY COMPRESSED ARROW": "1F841",
        "LEFTWARDS HEAVY ARROW": "1F844",
        "LEFT RIGHT SANS-SERIF ARROW": "1F858",
        "WIDE-HEADED RIGHTWARDS HEAVY BARB ARROW": "1F87A",
        "RIGHTWARDS BOTTOM SHADED WHITE ARROW": "1F8A1",
        "WHITE ARROW SHAFT WIDTH TWO THIRDS": "1F8AD",
        "WRESTLERS": "1F93C",
        "SPOON": "1F944",
        "FACE WITH PARTY HORN AND PARTY HAT": "1F973",
        "HEDGEHOG": "1F994",
        "SLOTH": "1F9A5",
        "BONE": "1F9B4",
        "LEG": "1F9B5",
        "MAGNET": "1F9F2",
        "SPONGE": "1F9FD",
        "BLACK CHESS PAWN ROTATED NINETY DEGREES": "1FA14",
        "WHITE CHESS TURNED BISHOP": "1FA21",
        "BLACK CHESS TURNED KING": "1FA24",
        "BLACK CHESS KING ROTATED TWO HUNDRED SEVENTY DEGREES": "1FA39",
        "XIANGQI RED MANDARIN": "1FA61",
        "XIANGQI RED ELEPHANT": "1FA62",
        "XIANGQI RED CANNON": "1FA65",
        "XIANGQI BLACK SOLDIER": "1FA6D",
        "THONG SANDAL": "1FA74",
        "MARACAS": "1FA87",
        "RINGED PLANET": "1FA90",
        "CHAIR": "1FA91",
        "BEANS": "1FAD8",
        "BLOCK SEXTANT-13": "1FB04",
        "BLOCK SEXTANT-124": "1FB0A",
        "BLOCK SEXTANT-46": "1FB26",
        "VERTICAL ONE EIGHTH BLOCK-3": "1FB71",
        "LEFT AND UPPER ONE EIGHTH BLOCK": "1FB7D",
        "UPPER SEVEN EIGHTHS BLOCK": "1FB86",
        "RIGHT HALF MEDIUM SHADE": "1FB8D",
        "BOX DRAWINGS LIGHT DIAGONAL MIDDLE LEFT TO LOWER CENTRE": "1FBA2",
        "BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE LEFT AND MIDDLE RIGHT TO LOWER CENTRE": "1FBA8",
        "INVERSE DOWNWARDS ARROW WITH TIP LEFTWARDS": "1FBB4",
        "MIDDLE THIRD WHITE RIGHT POINTING INDEX": "1FBC2",
        "<CJK Ideograph Extension C, Last>": "2B739",
        "CJK COMPATIBILITY IDEOGRAPH-2F82A": "2F82A",
        "CJK COMPATIBILITY IDEOGRAPH-2F837": "2F837",
        "CJK COMPATIBILITY IDEOGRAPH-2F854": "2F854",
        "CJK COMPATIBILITY IDEOGRAPH-2F877": "2F877",
        "CJK COMPATIBILITY IDEOGRAPH-2F88D": "2F88D",
        "CJK COMPATIBILITY IDEOGRAPH-2F8B0": "2F8B0",
        "CJK COMPATIBILITY IDEOGRAPH-2F8C6": "2F8C6",
        "CJK COMPATIBILITY IDEOGRAPH-2F8CD": "2F8CD",
        "CJK COMPATIBILITY IDEOGRAPH-2F8D0": "2F8D0",
        "CJK COMPATIBILITY IDEOGRAPH-2F8E6": "2F8E6",
        "CJK COMPATIBILITY IDEOGRAPH-2F8F6": "2F8F6",
        "CJK COMPATIBILITY IDEOGRAPH-2F904": "2F904",
        "CJK COMPATIBILITY IDEOGRAPH-2F915": "2F915",
        "CJK COMPATIBILITY IDEOGRAPH-2F91A": "2F91A",
        "CJK COMPATIBILITY IDEOGRAPH-2F936": "2F936",
        "CJK COMPATIBILITY IDEOGRAPH-2F950": "2F950",
        "CJK COMPATIBILITY IDEOGRAPH-2F966": "2F966",
        "CJK COMPATIBILITY IDEOGRAPH-2F973": "2F973",
        "CJK COMPATIBILITY IDEOGRAPH-2F991": "2F991",
        "CJK COMPATIBILITY IDEOGRAPH-2F9B5": "2F9B5",
        "CJK COMPATIBILITY IDEOGRAPH-2F9E3": "2F9E3",
        "CJK COMPATIBILITY IDEOGRAPH-2F9EF": "2F9EF",
        "CJK COMPATIBILITY IDEOGRAPH-2F9F9": "2F9F9",
        "CJK COMPATIBILITY IDEOGRAPH-2FA08": "2FA08",
        "CJK COMPATIBILITY IDEOGRAPH-2FA0A": "2FA0A",
        "TAG GRAVE ACCENT": "E0060",
        "VARIATION SELECTOR-34": "E0111",
        "VARIATION SELECTOR-36": "E0113",
        "VARIATION SELECTOR-73": "E0138",
        "VARIATION SELECTOR-99": "E0152",
        "VARIATION SELECTOR-160": "E018F",
        "VARIATION SELECTOR-166": "E0195",
        "VARIATION SELECTOR-195": "E01B2",
        "VARIATION SELECTOR-231": "E01D6"
    },
    "numerics": {
        "": "0000",
        "0": "0030",
        "1": "0031",
        "2": "0032",
        "3": "0033",
        "4": "0034",
        "5": "0035",
        "6": "0036",
        "7": "0037",
        "8": "0038",
        "9": "0039",
        "1/4": "00BC",
        "1/2": "00BD",
        "3/4": "00BE",
        "1/16": "09F4",
        "1/8": "09F5",
        "3/16": "09F6",
        "16": "09F9",
        "10": "0BF0",
        "100": "0BF1",
        "1000": "0BF2",
        "1/160": "0D58",
        "1/40": "0D59",
        "3/80": "0D5A",
        "1/20": "0D5B",
        "1/10": "0D5C",
        "3/20": "0D5D",
        "1/5": "0D5E",
        "3/2": "0F2B",
        "5/2": "0F2C",
        "7/2": "0F2D",
        "9/2": "0F2E",
        "11/2": "0F2F",
        "13/2": "0F30",
        "15/2": "0F31",
        "17/2": "0F32",
        "-1/2": "0F33",
        "20": "1373",
        "30": "1374",
        "40": "1375",
        "50": "1376",
        "60": "1377",
        "70": "1378",
        "80": "1379",
        "90": "137A",
        "10000": "137C",
        "17": "16EE",
        "18": "16EF",
        "19": "16F0",
        "1/7": "2150",
        "1/9": "2151",
        "1/3": "2153",
        "2/3": "2154",
        "2/5": "2156",
        "3/5": "2157",
        "4/5": "2158",
        "1/6": "2159",
        "5/6": "215A",
        "3/8": "215C",
        "5/8": "215D",
        "7/8": "215E",
        "11": "216A",
        "12": "216B",
        "500": "216E",
        "5000": "2181",
        "50000": "2187",
        "100000": "2188",
        "13": "246C",
        "14": "246D",
        "15": "246E",
        "21": "3251",
        "22": "3252",
        "23": "3253",
        "24": "3254",
        "25": "3255",
        "26": "3256",
        "27": "3257",
        "28": "3258",
        "29": "3259",
        "31": "325B",
        "32": "325C",
        "33": "325D",
        "34": "325E",
        "35": "325F",
        "36": "32B1",
        "37": "32B2",
        "38": "32B3",
        "39": "32B4",
        "41": "32B6",
        "42": "32B7",
        "43": "32B8",
        "44": "32B9",
        "45": "32BA",
        "46": "32BB",
        "47": "32BC",
        "48": "32BD",
        "49": "32BE",
        "200": "1011A",
        "300": "1011B",
        "400": "1011C"
    }
}

for bidir, cp in tests["bidirs"].items():
    assert bidir == unicodedata.bidirectional(chr(int(cp, 16)))

print("bidirectional ok")

for category, cp in tests["categories"].items():
    assert category == unicodedata.category(chr(int(cp, 16)))

print("categories ok")

for comb, cp in tests["combinings"].items():
    assert int(comb) == unicodedata.combining(chr(int(cp, 16)))

print("combining ok")

for decimal, cp in tests["decimals"].items():
    if decimal:
        assert eval(decimal) == unicodedata.decimal(chr(int(cp, 16)))

print("decimals ok")

for decomp, cp in tests["decompositions"].items():
    assert decomp == unicodedata.decomposition(chr(int(cp, 16)))

print("decomposition ok")

for digit, cp in tests["digits"].items():
    if digit:
        assert eval(digit) == unicodedata.digit(chr(int(cp, 16)))

print("digits ok")

for name, cp in tests["names"].items():
    assert name == unicodedata.name(chr(int(cp, 16)))

print("names ok")

for numeric, cp in tests["numerics"].items():
    if numeric:
        assert eval(numeric) == unicodedata.numeric(chr(int(cp, 16)))

print("numeric ok")

assert unicodedata.normalize('NFC', chr(0x2162)) == "Ⅲ"
assert unicodedata.normalize('NFD', chr(0x2162)) == "Ⅲ"
assert unicodedata.normalize('NFKC', chr(0x2162)) == "III"
assert unicodedata.normalize('NFKD', chr(0x2162)) == "III"

print("normalize ok")
